--[[-----------------------------------------------------------------------------------------------------------------------------
Class Spells
These functions list the useable spells for each class and sets whether they are enabled.
---------------------------------------------------------------------------------------------------------------------------------]]

function RUI_PriestDefault()
	RUI_Chat("Setting Priest Defaults")
	RUI_Settings.RangeSpellName = "Renew"
		
	-- (No Modifier)
	RUI_SpellState[0].Button[1].SpellName = "Renew"
	RUI_SpellState[0].Button[2].SpellName = "Flash Heal"
	RUI_SpellState[0].Button[3].SpellName = "Prayer of Mending"
	RUI_SpellState[0].Button[4].SpellName = "Power Word: Shield"
	-- (Alt)
	RUI_SpellState[1].Button[1].SpellName = "Greater Heal"
	RUI_SpellState[1].Button[2].SpellName = "Circle of Healing"
	RUI_SpellState[1].Button[3].SpellName = "Dispel Magic"
	RUI_SpellState[1].Button[4].SpellName = "Abolish Disease"
	-- (Ctrl)
	RUI_SpellState[2].Button[1].SpellName = "Guardian Spirit"
	RUI_SpellState[2].Button[2].SpellName = "Binding Heal"
	-- (Shift)
	RUI_SpellState[3].Button[1].SpellName = "Prayer of Spirit"
	RUI_SpellState[3].Button[2].SpellName = "Prayer of Fortitude"
	RUI_SpellState[3].Button[3].SpellName = "Prayer of Shadow Protection"
end

function RUI_Priest_SetDefaultSpellsOptions()
	
	RUI_Chat("Loading Priest Spell Options")
	local i=1
	RUI_SpellList[i] = "Renew"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckIfActive = 1
	i=i+1 --2
	RUI_SpellList[i] = "Flash Heal"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	i=i+1 --3
	RUI_SpellList[i] = "Greater Heal"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions["Greater Heal"].CheckRange = 1
	i=i+1 --4
	RUI_SpellList[i] = "Prayer of Mending"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckIfActive = 1
	i=i+1 --5
	RUI_SpellList[i] = "Power Word: Shield"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckIfActive = 1
	RUI_SpellOptions[RUI_SpellList[i]].CheckDebuff = 1
	RUI_SpellOptions[RUI_SpellList[i]].DebuffWeakenedSoul = 1
	i=i+1 --6
	RUI_SpellList[i] = "Desperate Prayer"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	i=i+1 --7
	RUI_SpellList[i] = "Dispel Magic"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckIfActive = 1
	RUI_SpellOptions[RUI_SpellList[i]].CheckDebuff = 1
	RUI_SpellOptions[RUI_SpellList[i]].DebuffMagic = 1
	i=i+1 --8
	RUI_SpellList[i] = "Abolish Disease"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckIfActive = 1
	RUI_SpellOptions[RUI_SpellList[i]].CheckDebuff = 1
	RUI_SpellOptions[RUI_SpellList[i]].DebuffDisease = 1
	i=i+1 --9
	RUI_SpellList[i] = "Divine Spirit"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckIfActive = 1
	i=i+1 --10
	RUI_SpellList[i] = "Prayer of Spirit"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckIfActive = 1
	i=i+1 --11
	RUI_SpellList[i] = "Power Word: Fortitude"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckIfActive = 1
	i=i+1 --12
	RUI_SpellList[i] = "Shadow Protection"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckIfActive = 1
	i=i+1 --13
	RUI_SpellList[i] = "Prayer of Shadow Protection"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckIfActive = 1
	i=i+1 --14
	RUI_SpellList[i] = "Prayer of Fortitude"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckIfActive = 1
	i=i+1 --15
	RUI_SpellList[i] = "Inner Fire"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckIfActive = 1
	i=i+1 --16
	RUI_SpellList[i] = "Inner Focus"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	i=i+1 --17
	RUI_SpellList[i] = "Pain Suppression"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckIfActive = 1
	i=i+1 --18
	RUI_SpellList[i] = "Power Infusion"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckIfActive = 1
	i=i+1 --19
	RUI_SpellList[i] = "Penance"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	i=i+1 --20
	RUI_SpellList[i] = "Circle of Healing"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	i=i+1 --21
	RUI_SpellList[i] = "Guardian Spirit"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckIfActive = 1
	i=i+1 --22
	RUI_SpellList[i] = "Binding Heal"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	i=i+1 --23
	RUI_SpellList[i] = "Lesser Heal"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	i=i+1 --24
	RUI_SpellList[i] = "Heal"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	i=i+1 --25
	RUI_SpellList[i] = "Fade"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	i=i+1 --26
	RUI_SpellList[i] = "Fear Ward"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	i=i+1 --27
	RUI_SpellList[i] = "Levitate"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	i=i+1 --28
	RUI_SpellList[i] = "Prayer of Healing"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	i=i+1 --29
	RUI_SpellList[i] = "Divine Hymn"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	i=i+1 --30
	RUI_SpellList[i] = "Hymn of Hope"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	
end



function RUI_PaladinDefault()
	RUI_Chat("Setting Paladin Defaults")
	RUI_Settings.RangeSpellName = "Flash of Light"
		
	RUI_SpellState[0].Button[1].SpellName = "Flash of Light"		
	RUI_SpellState[0].Button[2].SpellName = "Holy Light"
	RUI_SpellState[0].Button[3].SpellName = "Holy Shock"
	RUI_SpellState[0].Button[4].SpellName = "Cleanse"
	-- (Alt)
	RUI_SpellState[1].Button[1].SpellName = "Hand of Protection"
	RUI_SpellState[1].Button[2].SpellName = "Hand of Freedom"
	RUI_SpellState[1].Button[3].SpellName = "Hand of Salvation"
	RUI_SpellState[1].Button[4].SpellName = "Lay on Hands"
	-- (Ctrl)
	RUI_SpellState[2].Button[1].SpellName = "Sacred Shield"
	RUI_SpellState[2].Button[2].SpellName = "Beacon of Light"
	RUI_SpellState[2].Button[3].SpellName = "Righteous Defense"
	RUI_SpellState[2].Button[4].SpellName = "Blessing of Might"
	-- (Shift)
	RUI_SpellState[3].Button[1].SpellName = "Blessing of Kings"
	RUI_SpellState[3].Button[2].SpellName = "Greater Blessing of Might"
	RUI_SpellState[3].Button[3].SpellName = "Greater Blessing of Wisdom"
	RUI_SpellState[3].Button[4].SpellName = "Greater Blessing of Kings"
end


function RUI_Paladin_SetDefaultSpellOptions()
	RUI_Chat("Setting Paladin Spell Option Defaults")
	local i=1
	RUI_SpellList[i] = "Flash of Light"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	
	i=i+1 --2
	RUI_SpellList[i] = "Holy Light"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	
	i=i+1 --3
	RUI_SpellList[i] = "Cleanse"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckDebuff = 1
	RUI_SpellOptions[RUI_SpellList[i]].DebuffDisease = 1
	RUI_SpellOptions[RUI_SpellList[i]].DebuffMagic = 1
	RUI_SpellOptions[RUI_SpellList[i]].DebuffPoison = 1
	
	i=i+1 --4
	RUI_SpellList[i] = "Hand of Protection"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckIfActive = 1
	
	i=i+1 --2
	RUI_SpellList[i] = "Hand of Freedom"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckIfActive = 1
	
	i=i+1 --6
	RUI_SpellList[i] = "Hand of Salvation"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckIfActive = 1
	
	i=i+1 --7
	RUI_SpellList[i] = "Blessing of Might"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckIfActive = 1
	
	i=i+1 --8
	RUI_SpellList[i] = "Blessing of Wisdom"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckIfActive = 1
	
	i=i+1 --9
	RUI_SpellList[i] = "Blessing of Kings"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckIfActive = 1
	
	
	i=i+1 --10
	RUI_SpellList[i] = "Greater Blessing of Might"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckIfActive = 1
	
	i=i+1 --11
	RUI_SpellList[i] = "Greater Blessing of Wisdom"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckIfActive = 1
	
	i=i+1 --12
	RUI_SpellList[i] = "Greater Blessing of Kings"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckIfActive = 1
		
	i=i+1 --13
	RUI_SpellList[i] = "Sacred Shield"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckIfActive = 1
		
	i=i+1 --14
	RUI_SpellList[i] = "Beacon of Light"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckIfActive = 1
	
	i=i+1 --15
	RUI_SpellList[i] = "Lay on Hands"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	
	i=i+1 --16
	RUI_SpellList[i] = "Divine Shield"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckIfActive = 1
	
	i=i+1 --17
	RUI_SpellList[i] = "Righteous Defense"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckIfActive = 1
	
	i=i+1 --18
	RUI_SpellList[i] = "Avenging Wrath"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckIfActive = 1
	
	i=i+1 --19
	RUI_SpellList[i] = "Hand of Sacrifice"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckIfActive = 1
	
	i=i+1 --20
	RUI_SpellList[i] = "Holy Shock"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	
	i=i+1 --21
	RUI_SpellList[i] = "Divine Favor"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckIfActive = 1
	
	i=i+1 --22
	RUI_SpellList[i] = "Seal of Wisdom"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckIfActive = 1
	
	i=i+1 --23
	RUI_SpellList[i] = "Seal of Life"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckIfActive = 1
	
	i=i+1 --24
	RUI_SpellList[i] = "Holy Light (Rank 5)"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	
	i=i+1 --25
	RUI_SpellList[i] = "Divine Protection"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckIfActive = 1
	
	i=i+1 --26
	RUI_SpellList[i] = "Divine Intervention"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckIfActive = 1
end





function RUI_DruidDefault()
	RUI_Chat("Setting Druid Defaults")
	RUI_Settings.RangeSpellName = "Regrowth"
	
	-- (None)
	RUI_SpellState[0].Button[1].SpellName = "Rejuvenation"
	RUI_SpellState[0].Button[2].SpellName = "Regrowth"
	RUI_SpellState[0].Button[3].SpellName = "Lifebloom"
	RUI_SpellState[0].Button[4].SpellName = "Nourish"
	RUI_SpellState[0].Button[5].SpellName = "Healing Touch"
	RUI_SpellState[0].Button[6].SpellName = "Wild Growth"
	-- (Alt)
	RUI_SpellState[1].Button[1].SpellName = "Abolish Poison"
	RUI_SpellState[1].Button[2].SpellName = "Remove Curse"
	RUI_SpellState[1].Button[3].SpellName = "Innervate"
	RUI_SpellState[1].Button[4].SpellName = "Rebirth"
	-- Party (Ctrl)
	RUI_SpellState[2].Button[1].SpellName = "Mark of the Wild"
	RUI_SpellState[2].Button[2].SpellName = "Thorns"
	RUI_SpellState[2].Button[3].SpellName = "Gift of the Wild"
	
end


function RUI_Druid_SetDefaultSpellOptions()
	RUI_Chat("Setting Druid Spell Option Defaults")
	local i=1
	RUI_SpellList[i] = "Rejuvenation"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckIfActive = 1
	RUI_SpellOptions[RUI_SpellList[i]].IsMine = 1
	
	i=2
	RUI_SpellList[i] = "Regrowth"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckIfActive = 1
	RUI_SpellOptions[RUI_SpellList[i]].IsMine = 1
	
	i=3
	RUI_SpellList[i] = "Healing Touch"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckIfActive = 1
	
	i=4
	RUI_SpellList[i] = "Abolish Poison"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckDebuff = 1
	RUI_SpellOptions[RUI_SpellList[i]].DebuffPoison = 1
	
	i=5
	RUI_SpellList[i] = "Remove Curse"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckDebuff = 1
	RUI_SpellOptions[RUI_SpellList[i]].DebuffCurse = 1
	
	i=6
	RUI_SpellList[i] = "Mark of the Wild"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckIfActive = 1
	
	
	i=7
	RUI_SpellList[i] = "Gift of the Wild"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckIfActive = 1
		
	i=8
	RUI_SpellList[i] = "Thorns"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckIfActive = 1
		
	i=9
	RUI_SpellList[i] = "Nature's Grasp"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckIfActive = 1
		
	i=10
	RUI_SpellList[i] = "Lifebloom"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckIfActive = 1
	RUI_SpellOptions[RUI_SpellList[i]].IsMine = 1
		
	i=11
	RUI_SpellList[i] = "Rebirth"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CastOnDead = 1
	
	i=12
	RUI_SpellList[i] = "Innervate"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckIfActive = 1
		
	i=13
	RUI_SpellList[i] = "Nourish"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	
	i=14
	RUI_SpellList[i] = "Swiftmend"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	
	i=15
	RUI_SpellList[i] = "Nature's Swiftness"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	
	i=16
	RUI_SpellList[i] = "Tranquility"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckIfActive = 1
	
	i=17
	RUI_SpellList[i] = "Wild Growth"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckIfActive = 1
	RUI_SpellOptions[RUI_SpellList[i]].IsMine = 1
end







function RUI_ShamanDefault()
	RUI_Chat("Setting Shaman Defaults")
	RUI_Settings.RangeSpellName = "Healing Wave"
		
	-- (None) 
	RUI_SpellState[0].Button[1].SpellName = "Lesser Healing Wave"
	RUI_SpellState[0].Button[2].SpellName = "Healing Wave"
	RUI_SpellState[0].Button[3].SpellName = "Earth Shield"
	RUI_SpellState[0].Button[4].SpellName = "Cleanse Spirit"
	-- (Alt)
	RUI_SpellState[1].Button[1].SpellName = "Chain Heal"
	RUI_SpellState[1].Button[2].SpellName = "Riptide"
	RUI_SpellState[1].Button[3].SpellName = "Water Walking"
end


function RUI_Shaman_SetDefaultSpellOptions()
	RUI_Chat("Setting Shaman Spell Option Defaults")
	
	local i=1
	RUI_SpellList[i] = "Lesser Healing Wave"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckIfActive = 1
	
	i=i+1 --2
	RUI_SpellList[i] = "Healing Wave"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	
	i=i+1 --3
	RUI_SpellList[i] = "Chain Heal"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	
	i=i+1 --4
	RUI_SpellList[i] = "Cleanse Spirit"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckDebuff = 1
	RUI_SpellOptions[RUI_SpellList[i]].DebuffDisease = 1
	RUI_SpellOptions[RUI_SpellList[i]].DebuffCurse = 1
	RUI_SpellOptions[RUI_SpellList[i]].DebuffPoison = 1
	
	i=i+1 --5
	RUI_SpellList[i] = "Earth Shield"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckIfActive = 1
	
	i=i+1 --6
	RUI_SpellList[i] = "Tidal Force"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckIfActive = 1
	
	i=i+1 --7
	RUI_SpellList[i] = "Riptide"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	--RUI_SpellOptions[RUI_SpellList[i]].CheckIfActive = 1
	
	i=i+1 --8
	RUI_SpellList[i] = "Bloodlust"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckIfActive = 1
	
	i=i+1 --9
	RUI_SpellList[i] = "Water Shield"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckIfActive = 1
	
	i=i+1 --10
	RUI_SpellList[i] = "Lightning Shield"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckIfActive = 1
	
	i=i+1 --11
	RUI_SpellList[i] = "Shamanistic Rage"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckIfActive = 1
	
	i=i+1 --12
	RUI_SpellList[i] = "Water Walking"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	
	i=i+1 --13
	RUI_SpellList[i] = "Rockbiter Weapon"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckIfActive = 1
	RUI_SpellOptions[RUI_SpellList[i]].WeaponBuff = 1
	
	i=i+1 --14
	RUI_SpellList[i] = "Flametongue Weapon"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckIfActive = 1
	RUI_SpellOptions[RUI_SpellList[i]].WeaponBuff = 1
	
	i=i+1 --15
	RUI_SpellList[i] = "Frostbrand Weapon"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckIfActive = 1
	RUI_SpellOptions[RUI_SpellList[i]].WeaponBuff = 1
	
	i=i+1 --16
	RUI_SpellList[i] = "Earthliving Weapon"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckIfActive = 1
	RUI_SpellOptions[RUI_SpellList[i]].WeaponBuff = 1
		
	i=i+1 --17
	RUI_SpellList[i] = "Windfury Weapon"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckIfActive = 1
	RUI_SpellOptions[RUI_SpellList[i]].WeaponBuff = 1
	
	i=i+1 --18
	RUI_SpellList[i] = "Nature's Swiftness"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckIfActive = 1
	
	i=i+1 --19
	RUI_SpellList[i] = "Ancestral Spirit"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	
	i=i+1 --20
	RUI_SpellList[i] = "Reincarnation"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	
	i=i+1 --21
	RUI_SpellList[i] = "Astral Recall"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	
	i=i+1 --22
	RUI_SpellList[i] = "Water Breathing"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckIfActive = 1
	
	i=i+1 --23
	RUI_SpellList[i] = "Cure Disease"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckDebuff = 1
	RUI_SpellOptions[RUI_SpellList[i]].DebuffDisease = 1
	
	i=i+1 --24
	RUI_SpellList[i] = "Cure Poison"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckDebuff = 1
	RUI_SpellOptions[RUI_SpellList[i]].DebuffPoison = 1
	
	i=i+1 --25
	RUI_SpellList[i] = "Ghost Wolf"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckIfActive = 1
	
	i=i+1 --26
	RUI_SpellList[i] = "Heroism"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckIfActive = 1
	
	i=i+1 --27
	RUI_SpellList[i] = "Lifeblood"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckIfActive = 1
	
	i=i+1 --28
	RUI_SpellList[i] = "Gift of the Naaru"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckIfActive = 1
	
	i=i+1 --29
	RUI_SpellList[i] = "Call of Fire"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	
	i=i+1 --30
	RUI_SpellList[i] = "Call of Earth"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	
	i=i+1 --31
	RUI_SpellList[i] = "Cure Toxins"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckDebuff = 1
	RUI_SpellOptions[RUI_SpellList[i]].DebuffDisease = 1
	RUI_SpellOptions[RUI_SpellList[i]].DebuffPoison = 1
	
end



function RUI_MonkDefault()
	RUI_Chat("Setting Monk Defaults")
	RUI_Settings.RangeSpellName = "Soothing Mist"
		
	-- (No Modifier)
	RUI_SpellState[0].Button[1].SpellName = "Soothing Mist"
	RUI_SpellState[0].Button[2].SpellName = "Enveloping Mist"
	RUI_SpellState[0].Button[3].SpellName = "Surging Mist"
	RUI_SpellState[0].Button[4].SpellName = "Zen Sphere"
	RUI_SpellState[0].Button[4].SpellName = "Detox"
	-- (Alt)
	--RUI_SpellState[1].Button[1].SpellName = ""
	
	-- (Ctrl)
	--RUI_SpellState[2].Button[1].SpellName = ""
	
	-- (Shift)
	--RUI_SpellState[3].Button[1].SpellName = ""
	
end

function RUI_Monk_SetDefaultSpellsOptions()
	
	RUI_Chat("Loading Monk Spell Options")
	local i=1
	RUI_SpellList[i] = "Soothing Mist"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckIfActive = 1
	i=i+1 --2
	RUI_SpellList[i] = "Enveloping Mist"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckIfActive = 1
	i=i+1 --3
	RUI_SpellList[i] = "Surging Mist"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	i=i+1 --4
	RUI_SpellList[i] = "Renewing Mist"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckIfActive = 1
	i=i+1 --5
	RUI_SpellList[i] = "Life Cocoon"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckIfActive = 1
	i=i+1 --6
	RUI_SpellList[i] = "Uplift"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	i=i+1 --7
	RUI_SpellList[i] = "Expel Harm"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	i=i+1 --8
	RUI_SpellList[i] = "Healing Sphere"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	i=i+1 --9
	RUI_SpellList[i] = "Detox"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckIfActive = 1
	RUI_SpellOptions[RUI_SpellList[i]].CheckDebuff = 1
	RUI_SpellOptions[RUI_SpellList[i]].DebuffDisease = 1
	RUI_SpellOptions[RUI_SpellList[i]].DebuffPoison = 1
	i=i+1 --10
	RUI_SpellList[i] = "Internal Medicine"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckIfActive = 1
	RUI_SpellOptions[RUI_SpellList[i]].CheckDebuff = 1
	RUI_SpellOptions[RUI_SpellList[i]].DebuffMagic = 1
	RUI_SpellOptions[RUI_SpellList[i]].DebuffPoison = 1
	i=i+1 --11
	RUI_SpellList[i] = "Tiger's Lust"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckIfActive = 1
	i=i+1 --12
	RUI_SpellList[i] = "Chi Wave"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	i=i+1 --13
	RUI_SpellList[i] = "Zen Sphere"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckIfActive = 1
	i=i+1 --14
	RUI_SpellList[i] = "Chi Burst"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	i=i+1 --15
	RUI_SpellList[i] = "Chi Brew"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	i=i+1 --16
	RUI_SpellList[i] = "Rushing Jade Wind"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckIfActive = 1
	i=i+1 --17
	RUI_SpellList[i] = "Chi Torpedo"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckIfActive = 1	
	i=i+1 --18
	RUI_SpellList[i] = "Legacy of the Emperor"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckIfActive = 1
	i=i+1 --19
	RUI_SpellList[i] = "Fortifying Brew"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckIfActive = 1
	i=i+1 --20
	RUI_SpellList[i] = "Mana Tea"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckIfActive = 1
	i=i+1 --21
	RUI_SpellList[i] = "Thunder Focus Tea"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckIfActive = 1
	i=i+1 --22
	RUI_SpellList[i] = "Summon Jade Serpent Statue"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	i=i+1 --23
	RUI_SpellList[i] = "Energizing Brew"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	i=i+1 --24
	RUI_SpellList[i] = "Tiger Eye Brew"
	RUI_SpellOptions[RUI_SpellList[i]] = {}
	RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_SpellList[i]
	RUI_SpellOptions[RUI_SpellList[i]].CheckIfActive = 1
end



--[[
	
	RUI_SpellSet[t].EnoughMana = {};
	for b = 1, RUI_Max_Buttons do
		RUI_SpellSet[t].EnoughMana[b] = nil
	end
		
	
	
	RUI_SpellSet[t].State[s].Button[b].CheckIfActive = nil
	RUI_SpellSet[t].State[s].Button[b].WeaponBuff = nil
	RUI_SpellSet[t].State[s].Button[b].WearOffAlert = nil
	RUI_SpellSet[t].State[s].Button[b].ShowDuration = nil
	RUI_SpellSet[t].State[s].Button[b].CheckDebuff = nil
	RUI_SpellSet[t].State[s].Button[b].DebuffMagic = nil
	RUI_SpellSet[t].State[s].Button[b].DebuffCurse = nil
	RUI_SpellSet[t].State[s].Button[b].DebuffPoison = nil
	RUI_SpellSet[t].State[s].Button[b].DebuffDisease = nil
	RUI_SpellSet[t].State[s].Button[b].DebuffWeakenedSoul = nil
]]
