
--[[ ===========================================================================================================================


							UPDATE BUTTOON FUNCTION

					
=================================================================================================================================]]

function RUI_Fav_ClearUFavButtons(tFavID)
	if not (tFavID) then return; end
	for b = 1, RUI_Max_Buttons do
		RUI_Fav[tFavID].IsActive[b] = nil
		RUI_Fav[tFavID].HasDebuff[b] = nil
		RUI_Fav[tFavID].LastExpTime[b] = nil
		if (RUI_Fav[tFavID].Button[b]) then
			if (RUI_Fav[tFavID].Button[b].icon) then
				RUI_Fav[tFavID].Button[b].icon:SetVertexColor(1, 1, 1, 1)
			end
			if (RUI_Fav[tFavID].Button[b].cooldown) then
				CooldownFrame_SetTimer( RUI_Fav[tFavID].Button[b].cooldown, 0, 0, 0)
			end
			if (RUI_Fav[tFavID].Button[b].Text) then
				RUI_Fav[tFavID].Button[b].Text:SetText("")
			end
		end
	end
end
function RUI_Fav_ClearButtons()
	for f = 1, RUI_Max_Favs do
		if (RUI_Fav[f].Show) then
			RUI_Fav_ClearUFavButtons(f)
		end
	end
end


function RUI_Fav_Button_Update(tUFrame, b)
	if (not tUFrame) or (not b) then return; end
	if not (RUI_Fav[tUFrame].Show) then return; end
	
	local s = RUI_Button_CurrentState
	if not (s) then return; end
	local tSpellName = RUI_SpellState[s].Button[b].SpellName
	if not (tSpellName) then
		if (RUI_Fav[tUFrame].Button[b]) then
			RUI_Fav[tUFrame].Button[b]:SetAlpha(0)
		end
		return;
	end
	if not (RUI_Fav[tUFrame].Button[b]) or not (RUI_Fav[tUFrame].Button[b].cooldown) or not (RUI_Fav[tUFrame].Button[b].Text) then return; end
	
	if (RUI_SpellOptions[tSpellName].CastOnDead) then
		if (RUI_Fav[tUFrame].IsDead) then
			RUI_Fav[tUFrame].Button[b]:SetAlpha(1)
		else
			RUI_Fav[tUFrame].Button[b]:SetAlpha(0.3)
		end
	end
	
	-- If CheckActive and spell NOT active then UnDim
	if (RUI_SpellOptions[tSpellName].CheckIfActive) then
		local exptime, duration, count, active = RUI_Get_Buff_Times(RUI_Fav_List[tUFrame], tSpellName, RUI_SpellOptions[tSpellName].IsMine) --RUI_Unit[RUI_Fav[tUFrame].UnitNumber].Unit, tSpellName)
		if (active) then -- Buff is Active, set cooldown to show buff duration
			if (count) and (tonumber(count)>0) then
				RUI_Fav[tUFrame].Button[b].Text:SetText(count)
			else
				RUI_Fav[tUFrame].Button[b].Text:SetText("")
			end
			if (duration) and (exptime) then
				if not (RUI_Fav[tUFrame].LastExpTime[b]) or not (exptime==RUI_Fav[tUFrame].LastExpTime[b]) then
					RUI_Fav[tUFrame].LastExpTime[b] = exptime
					local start = GetTime() - (duration - (exptime - GetTime()))
					CooldownFrame_SetTimer(RUI_Fav[tUFrame].Button[b].cooldown, start, duration, 1)
					RUI_Fav[tUFrame].IsActive[b] = 1
				end
			end
			RUI_Fav[tUFrame].Button[b].icon:SetVertexColor(0, 1, 0, 0.7)
			RUI_Fav[tUFrame].Button[b]:SetAlpha(1)
			return
		else -- Check if button thinks it's active and clear cooldown if it isn't 
			if (RUI_Fav[tUFrame].IsActive[b]) then
				--RUI_Fav[tUFrame].Button[b].cooldown:SetBackdropColor(0.3, 0.3, 0.3)
				RUI_Fav[tUFrame].Button[b].icon:SetVertexColor(1, 1, 1, 1)
				local start, duration, enable = GetSpellCooldown(tSpellName);
				if (start) and (duration) then
					CooldownFrame_SetTimer( RUI_Fav[tUFrame].Button[b].cooldown, start, duration, enable)
				else
					CooldownFrame_SetTimer( RUI_Fav[tUFrame].Button[b].cooldown, 0, 0, 0)
				end
				RUI_Fav[tUFrame].IsActive[b] = nil
				RUI_Fav[tUFrame].Button[b].Text:SetText("")
			end
		end
	end
		
	-- If CheckDebuff and has debuff UnDim
	if ( RUI_SpellOptions[tSpellName].CheckDebuff) then
		local found = nil
		if (RUI_SpellOptions[tSpellName].DebuffMagic) and (RUI_Fav[tUFrame].HasMagic) then found=1; end -- Check for Magic Debuff
		if not (found) and (RUI_SpellOptions[tSpellName].DebuffCurse) and (RUI_Fav[tUFrame].HasCurse) then found=1; end -- Check for Curse Debuff
		if not (found) and (RUI_SpellOptions[tSpellName].DebuffPoison) and (RUI_Fav[tUFrame].HasPoison) then found=1; end -- Check for Poison Debuff
		if not (found) and (RUI_SpellOptions[tSpellName].DebuffDisease) and (RUI_Fav[tUFrame].HasDisease) then found=1;	end -- Check for Disease Debuff
		if not (found) and (RUI_SpellOptions[tSpellName].DebuffWeakenedSoul) and (RUI_Fav[tUFrame].HasWS) then found=1;	end -- Weakened soul has the oposite effect, if the debuff is there gray out button 
		if (found) then
			if not (RUI_Fav[tUFrame].HasDebuff[b]) then
				RUI_Fav[tUFrame].Button[b].icon:SetVertexColor(1, 0, 0, 0.7)
				RUI_Fav[tUFrame].Button[b]:SetAlpha(1)
				RUI_Fav[tUFrame].HasDebuff[b] = 1;
			end
		else -- If no debuff found stop cooldown and dim button
			if (RUI_Fav[tUFrame].HasDebuff[b]) then
				RUI_Fav[tUFrame].Button[b].icon:SetVertexColor(1, 1, 1, 1)
				RUI_Fav[tUFrame].HasDebuff[b] = nil
			end
			RUI_Fav[tUFrame].Button[b]:SetAlpha(0.3)
			return
		end
	end

	RUI_Fav[tUFrame].Button[b]:SetAlpha(1)
end



function RUI_Fav_Update_Buttons()
	if (RUI_Num_Favs<1) then return; end
	
	for f = 1, RUI_Num_Favs do
		if (RUI_Fav[f].Show) then
			for b = 1, RUI_Max_Buttons do
				RUI_Fav_Button_Update(f, b)
			end
		end
	end
end


function RUI_FavFrame_Buttons_UpdateUnit(tUFrame)
	if not (tUFrame) then return; end
	--if not (RUI_Fav[tUFrame].UnitNumber) then return; end
	
	for b = 1, RUI_Max_Buttons do
		local button = RUI_Fav[tUFrame].Button[b]
		if (button) then
			button:SetAttribute("unit", RUI_Fav_List[tUFrame]) --RUI_Unit[RUI_Fav[tUFrame].UnitNumber].Unit)
		end
	end
end


--[[ ===========================================================================================================================


							CONFIG BUTTOON FUNCTION

					
=================================================================================================================================]]





--[[ ===========================================================================================================================
					ToolTip Functions
=================================================================================================================================]]
-- OnLeave function.  Added to a button to allow calling it via control:CallMethod("TooltipHide")
local function TooltipHide()
        GameTooltip:Hide()
end

-- Generic Tooltip function
local function TooltipShow(button)
	if not (RUI_Settings.TooltipEnable) then return; end
	local SpellName = button:GetAttribute("spell");
	if not (SpellName) then return; end
	--GameTooltip:SetOwner(this, 'ANCHOR_BOTTOMRIGHT');
	GameTooltip:SetOwner(button, "ANCHOR_RIGHT");
	--GameTooltip:SetPoint("TOPLEFT", this , "TOPRIGHT", 0, 0);
	GameTooltip:SetText(SpellName);
    --GameTooltip:AddLine(SpellName, 0.2, 0.8, 0.8)
    GameTooltip:Show();
	button.UpdateTooltip = TooltipShow;
end

local function TooltipApply(button)
        button.TooltipShow = TooltipShow
        button.TooltipHide = TooltipHide
        SecureHandlerWrapScript(button, "OnEnter", button, [[ control:CallMethod("TooltipShow", self) ]])
        SecureHandlerWrapScript(button, "OnLeave", button, [[ control:CallMethod("TooltipHide") ]])
end

--[[ ===========================================================================================================================
					Cool Down Functions
=================================================================================================================================]]
function RUI_Fav_UpdateCooldown(arg1)
	if not (arg1) then return; end
	-- Check if Cooldown is being used by an Active Buff or Debuff to show duration
	local tUFrame = arg1:GetAttribute("UFrame")
	local b = arg1:GetAttribute("ButtonNum")
	if not (tUFrame) or not (b) then return; end
	RUI_Button_Update(tUFrame, b)
	if (RUI_Fav[tUFrame].IsActive[b]) then return; end
	
	local tSpellName = arg1:GetAttribute("spell")
	if not (tSpellName) then return; end
	
	local start, duration, enable = GetSpellCooldown(tSpellName);
	if not (arg1.cooldown) or not (start) or not (duration) then
		return
	end
	if not (enable) then
		enable = 1
	end

	CooldownFrame_SetTimer( arg1.cooldown, start, duration, enable)
end


--[[ ===========================================================================================================================
					Create Button Functions
=================================================================================================================================]]

local function UdateIcon(button, spellname, test, newstate)

	local spellname = button:GetAttribute("spell")
	if (spellname) then
		button.icon:SetTexture(GetSpellTexture(spellname))
		button:SetAlpha(1)
	else
		button:SetAlpha(0)
	end
	if (newstate) then
		newstate = tonumber(newstate)
		if (newstate) then
			RUI_ClearButtons()
			RUI_Button_CurrentState = newstate
		end
	end
	RUI_Update_Buttons()
end

local stateSpellSnippet = [[
	newstate = tonumber(newstate)
	if (newstate == 1) then
		self:SetAttribute("spell", self:GetAttribute("spell-S1"))
	elseif (newstate == 2) then
		self:SetAttribute("spell", self:GetAttribute("spell-S2"))
	elseif (newstate == 3) then
		self:SetAttribute("spell", self:GetAttribute("spell-S3"))
	else
		self:SetAttribute("spell", self:GetAttribute("spell-S0"))
	end
	control:CallMethod("UdateIcon", self, self:GetAttribute("spell"), newstate)
	control:CallMethod("RUI_Fav_UpdateCooldown", self)
]]

local spellModStates = "[modifier:alt] 1; [modifier:ctrl] 2; [modifier:shift] 3; 0"





function RUI_Fav_Config_Button(tUFrame, tButton, tAnchorTo)
	local tButton_Size = 36 
	local tButton_Spacing = 5 
	local hdr = RUI_Fav[tUFrame].Header:GetName();
	local hndlr = RUI_Fav[tUFrame].Handler;
	local button = RUI_Fav[tUFrame].Button[tButton]
	
	local buttonName = "RUI_Favs" .. tUFrame .. "_B" .. tButton
	if (not button) then	
		button = CreateFrame("Button", buttonName, hndlr, "ActionButtonTemplate SecureActionButtonTemplate SecureHandlerStateTemplate")		
		button.icon = _G[buttonName.."Icon"]
		button.cooldown = _G[buttonName.."Cooldown"]
		button.UdateIcon = UdateIcon
		hndlr:SetAttribute("_adopt", button)
		button:RegisterForClicks("AnyUp");
		button.Text = button:CreateFontString(buttonName.."_Text", "ARTWORK", "GameFontHighlightLarge")
		button.Text:SetPoint("CENTER")
		button.Text:SetTextColor(1,1,1)
	end
	button.Text:SetText("")
		
	local tSpellName1 = RUI_SpellState[0].Button[tButton].SpellName
	local tSpellName2 = RUI_SpellState[1].Button[tButton].SpellName
	local tSpellName3 = RUI_SpellState[2].Button[tButton].SpellName
	local tSpellName4 = RUI_SpellState[3].Button[tButton].SpellName
		
	if (tSpellName1) and (GetSpellTexture(tSpellName1)) then
		button.icon:SetTexture(GetSpellTexture(tSpellName1))
	end
	button.icon:Show()
		
	button.RUI_Fav_UpdateCooldown = RUI_Fav_UpdateCooldown
	button:RegisterEvent('SPELL_UPDATE_COOLDOWN');
	button:SetScript("OnEvent", RUI_Fav_UpdateCooldown)
		
	--TooltipApply(button)
		
	button:SetAttribute("type", "spell")
	
	if not (RUI_Settings.DisableModifiers) then
		button:SetAttribute("_onstate-modstates", stateSpellSnippet)
		RegisterStateDriver(button, "modstates", spellModStates) -- The states are combined into the same string
	end
    
	button:SetAttribute("spell-S0", tSpellName1)
	button:SetAttribute("spell-S1", tSpellName2)
	button:SetAttribute("spell-S2", tSpellName3)
	button:SetAttribute("spell-S3", tSpellName4)
	button:SetAttribute("UFrame", tUFrame)
	button:SetAttribute("ButtonNum", tButton)
	
	button:SetAttribute("unit", RUI_Fav_List[tUFrame]) --RUI_Unit[RUI_Fav[tUFrame].UnitNumber].Unit)

	button:ClearAllPoints()
	button:SetHeight(36) --tButton_Size)
    button:SetWidth(36)  --tButton_Size)
    button:Show()
	
	-- Position Button
	button:SetPoint("RIGHT", hdr , "RIGHT", (-40*(RUI_Settings.NumberButtons-tButton+1))+35, 0)
	
	if (tButton<=RUI_Settings.NumberButtons) then
		button:Show()
	else
		button:Hide()
	end
	
	-- Save the button frame info in RUI_BUTTONS for later use
	RUI_Fav[tUFrame].Button[tButton] = button
	
	button:SetAttribute("spell", tSpellName1)
	button:SetAttribute("state", 1);
end


