function RUI_Init_Fav_Values()
	
	for s=0, RUI_Max_Favs do
		RUI_Fav[s] = {}
		RUI_Fav[s].UnitNumber = nil -- Which RUI_Unit this UFrame is showing
		RUI_Fav[s].Show = nil -- Whether the UFrame should be shown
	
		RUI_Fav[s].Header = nil -- The header of the Unit Frame
		RUI_Fav[s].Handler = nil
		RUI_Fav[s].Button = {}
		RUI_Fav[s].Button[0] = nil
		RUI_Fav[s].IsActive = {}
		RUI_Fav[s].HasDebuff = {}
		RUI_Fav[s].LastExpTime = {}
		
		RUI_Fav[s].HasCurse = nil
		RUI_Fav[s].HasDisease = nil
		RUI_Fav[s].HasPoison = nil
		RUI_Fav[s].HasMagic = nil
		RUI_Fav[s].HasWS = nil
		
		RUI_Fav[s].IsDead = nil
		
		for t = 0, RUI_Max_Buttons do
			RUI_Fav[s].Button[t] = nil -- Create reference and default value to nil for Buttons of this UFrame
			RUI_Fav[s].IsActive[t] = nil-- Tracks whether the mod thinks the button is active. So can clear cooldown if it isn't
			RUI_Fav[s].HasDebuff[t] = nil
			RUI_Fav[s].LastExpTime[t] = nil
		end
		RUI_Fav[s].LastHealth = 0 -- Last checked Health value, used to decide whether to update healthbar.
	end
	RUI_Fav_List_Clear()
end


function RUI_Fav_Swap(FavID1, FavID2)
	if not (FavID1) or not (FavID2) then return; end

	RUI_Fav_List[FavID1], RUI_Fav_List[FavID2] = RUI_Fav_List[FavID2], RUI_Fav_List[FavID1]
	RUI_Fav[FavID1].UnitNumber, RUI_Fav[FavID2].UnitNumber = RUI_Fav[FavID2].UnitNumber, RUI_Fav[FavID1].UnitNumber
	RUI_Fav[FavID1].Show, RUI_Fav[FavID2].Show = RUI_Fav[FavID2].Show, RUI_Fav[FavID1].Show
	RUI_Fav[FavID1].HasCurse, RUI_Fav[FavID2].HasCurse = RUI_Fav[FavID2].HasCurse, RUI_Fav[FavID1].HasCurse
	RUI_Fav[FavID1].HasDisease, RUI_Fav[FavID2].HasDisease = RUI_Fav[FavID2].HasDisease, RUI_Fav[FavID1].HasDisease
	RUI_Fav[FavID1].HasPoison, RUI_Fav[FavID2].HasPoison = RUI_Fav[FavID2].HasPoison, RUI_Fav[FavID1].HasPoison
	RUI_Fav[FavID1].HasMagic, RUI_Fav[FavID2].HasMagic = RUI_Fav[FavID2].HasMagic, RUI_Fav[FavID1].HasMagic
	RUI_Fav[FavID1].HasWS, RUI_Fav[FavID2].HasWS = RUI_Fav[FavID2].HasWS, RUI_Fav[FavID1].HasWS
	
	RUI_Fav_ClearUFavButtons(FavID1)
	RUI_FavFrame_Buttons_UpdateUnit(FavID1)
	RUI_Fav_SetFrame(FavID1)
	RUI_Fav_ClearUFavButtons(FavID2)
	RUI_FavFrame_Buttons_UpdateUnit(FavID2)
	RUI_Fav_SetFrame(FavID2)
	RUI_Refresh_Favs()
end

function RUI_Fav_CopyUFrame(FavID, UFrameID)
	RUI_Fav[FavID].UnitNumber = RUI_UFrame[UFrameID].UnitNumber
	RUI_Fav[FavID].Show = 1
	RUI_Fav[FavID].HasCurse = RUI_UFrame[UFrameID].HasCurse
	RUI_Fav[FavID].HasDisease = RUI_UFrame[UFrameID].HasDisease
	RUI_Fav[FavID].HasPoison = RUI_UFrame[UFrameID].HasPoison
	RUI_Fav[FavID].HasMagic = RUI_UFrame[UFrameID].HasMagic
	RUI_Fav[FavID].HasWS = RUI_UFrame[UFrameID].HasWS
	RUI_Fav[FavID].LastHealth = 0
end

function RUI_Fav_List_Clear()
	for s=0, RUI_Max_Favs do
		RUI_Fav_List[s] = nil
	end
	RUI_Num_Favs = 0
	-- Hide Fav UFrames
	RUI_Fav_Change = 1
end

function RUI_Fav_List_Add(tUFrameID)
	if not (tUFrameID) then return; end
	if (RUI_Num_Favs>=RUI_Max_Favs) then
		RUI_Chat("Unable to Add to Favorites. Too Many Favorites.")
		return
	end
	--if (RUI_UFrame[tUFrameID].UnitNumber)
	local tName = UnitName(RUI_Unit[RUI_UFrame[tUFrameID].UnitNumber].Unit)
	local found = nil
	for i=1, RUI_Num_Favs do
		if (tName == RUI_Fav_List[RUI_Num_Favs]) then found = 1; end
	end
	if (found) then
		RUI_Chat("Name already in favorites list.")
		return
	end
	RUI_Chat("Adding "..tName.." to Favorites")
	RUI_Num_Favs = RUI_Num_Favs + 1
	RUI_Fav_List[RUI_Num_Favs] = tName
	RUI_Fav_CopyUFrame(RUI_Num_Favs, tUFrameID)
	RUI_UFrame_SetAsFavorite(tUFrameID)
	
	RUI_Fav_ClearUFavButtons(RUI_Num_Favs)
	RUI_FavFrame_Buttons_UpdateUnit(RUI_Num_Favs)
	RUI_Fav_SetFrame(RUI_Num_Favs)
	RUI_UFrames_DimFavorite_UFrame(tUFrameID)
	RUI_Fav_SetFavoritesFrame()
	RUI_Refresh_Favs()
end

function RUI_Fav_List_RemoveID(tID)
	if not (tID) then return; end
	if (tID>RUI_Num_Favs) then return; end
	if (tID==RUI_Num_Favs) then 
		RUI_Num_Favs = RUI_Num_Favs - 1
		RUI_Fav_Change = 1
		RUI_Fav_SetFavoritesFrame()
		return;
	end
	
	--local tName = RUI_Fav_List[tID]
	local tUFrame = RUI_Fav_FindUFrame_FromName(RUI_Fav_List[tID])
	if (tUFrame) then
		RUI_UFrame[tUFrame].IsFavorite=nil
		RUI_Refresh_UFrames()
	end
	
	for s=tID, RUI_Num_Favs-1 do
		RUI_Fav_List[s] = RUI_Fav_List[s+1]
		RUI_Fav_ClearUFavButtons(s)
		RUI_FavFrame_Buttons_UpdateUnit(s)
		RUI_Fav_SetFrame(s)
	end
	RUI_Num_Favs = RUI_Num_Favs - 1
	--RUI_Fav_Change = 1
	RUI_Fav_SetFavoritesFrame()
end

function RUI_Fav_List_Remove(tName)
	if not (tName) then return; end
	if (RUI_Num_Favs<1) then return; end
	
	for s=1, RUI_Num_Favs do
		if (tName==RUI_Fav_List[s]) then
			RUI_Fav_List_RemoveID(s)
		end
	end
end

function RUI_Fav_List_Print()
	if (RUI_Num_Favs<1) then 
		RUI_Chat("Favorites List is Empty")
		return
	end
	
	RUI_Chat("Favorites List")
	for s=1, RUI_Num_Favs do
		RUI_Chat(s..". "..RUI_Fav_List[s])
	end
end



function RUI_Fav_List_Update()
	for s=0, RUI_Max_UFrames do
		RUI_UFrame[s].IsFavorite = nil
	end
	if (RUI_Num_Favs<1) then 
		RUI_UFrames_DimFavorites()
		return; 
	end
	
	for s=1, RUI_Num_Favs do
		local found = nil
		for r=0, RUI_Num_UFrames do
			local rName = UnitName(RUI_Unit[RUI_UFrame[r].UnitNumber].Unit)
			if (rName) and (RUI_Fav_List[s] == rName) then
				found = 1
				RUI_Fav[s].UnitNumber = r -- Copy info
				RUI_UFrame_SetAsFavorite(r)
			end
		end
		if not (found) then
			RUI_Chat("Favorite "..RUI_Fav_List[s].." Not Found, Removing.")
			RUI_Fav_List_Remove(RUI_Fav_List[s])
		end
	end
	
	RUI_UFrames_DimFavorites()
	--RUI_FavFrame_Buttons_UpdateUnit()
	--RUI_Fav_ClearButtons()
end


function RUI_Fav_FindUFrame_FromName(tName)
	if not (tName) then return; end
	for f = 0, RUI_Num_UFrames do
		if (RUI_UFrame[f].UnitNumber) and (RUI_Unit[RUI_UFrame[f].UnitNumber].Unit) then
			if (tName==UnitName(RUI_Unit[RUI_UFrame[f].UnitNumber].Unit)) then
				return f
			end
		end
	end
end



function RUI_Fav_Set_Debuffs(tUFrame) -- Returns poison, disease, magic, curse, weakenedsoul, Spiritofredemption
	RUI_UFrame[tUFrame].HasCurse = nil
	RUI_UFrame[tUFrame].HasDisease = nil
	RUI_UFrame[tUFrame].HasPoison = nil
	RUI_UFrame[tUFrame].HasMagic = nil
	RUI_UFrame[tUFrame].HasWS = nil
	
	local tUnit_Name = RUI_Fav_List[tUFrame] --RUI_Unit[RUI_UFrame[tUFrame].UnitNumber].Unit
	--local spirit_of_redemption = nil; 
			
	local i = 1;
	local name, rank, icon, count, debuffType, duration, timeLeft, isMine, isStealable;		
	local name = "test"
	while ( name ) do		
		name, rank, icon, count, debuffType, duration, timeLeft, isMine, isStealable = UnitDebuff(tUnit_Name, i);
		if (debuffType) then
			if (debuffType == "Curse") then 
				RUI_Fav[tUFrame].HasCurse = true; 
			end
			if (debuffType == "Disease") then 
				RUI_Fav[tUFrame].HasDisease = true; 
			end
			if (debuffType == "Magic") then 
				RUI_Fav[tUFrame].HasMagic = true; 
			end
			if (debuffType == "Poison") then 
				RUI_Fav[tUFrame].HasPoison = true; 
			end
		end
		if (name) then
			if (name=="Weakened Soul") then RUI_Fav[tUFrame].HasWS = true; end;
			--if (name=="Spirit of Redemption") then spirit_of_redemption = true; end;
		end
		i = i + 1;
		if i>30 then return; end
	end
end



function RUI_Fav_MoveToTop(FrameID)
	if not (FrameID) or (FrameID<2) then return; end
	for i= FrameID, 2, -1 do
		RUI_Fav_Swap(FrameID, FrameID-1)
	end
end

function RUI_Fav_MoveToBottom(FrameID)
	if not (FrameID) or (FrameID>=RUI_Num_Favs) then return; end
	for i= FrameID, RUI_Num_Favs-1 do
		RUI_Fav_Swap(FrameID, FrameID+1)
	end
end