function RUI_Fav_Min_Click()
	RUI_Fav_Hide_Panel()
	RUI_Settings.HideFavPanel = 1
end

function RUI_Fav_Max_Click()
	RUI_Fav_Show_Panel()
	RUI_Settings.HideFavPanel = nil
end

function RUI_Fav_Hide_Header()
	RUI_Fav_Header_Frame:Hide()
end

function RUI_Fav_Show_Header()
	RUI_Fav_Header_Frame:Show()
end

--[[ ===========================================================================================================================

					RaidUI FAVORITE FRAME AND BUTTON REFRESH FUNCTIONS
					
					
=================================================================================================================================]]

--[[ ===========================================================================================================================
					UFRAME CLICK FUNCTIONS 
=================================================================================================================================]]


function RUI_Fav_Clear_Click()
	if (InCombatLockdown()) then
		RUI_Chat("Can't Modify Favorites in Combat")
		return;
	end
	RUI_Num_Favs = 0
	RUI_Fav_Change = 1
end

function RUI_Fav_AddAll_Click()
	if (InCombatLockdown()) then
		RUI_Chat("Can't Modify Favorites in Combat")
		return;
	end
	
	for r=0, RUI_Num_UFrames do
		local found = nil
		local rName = UnitName(RUI_Unit[RUI_UFrame[r].UnitNumber].Unit)
		if (rName) then
			for s=1, RUI_Num_Favs do
				if (RUI_Fav_List[s] == rName) then
					found = 1
					break;
				end
			end
			if not (found) then
				RUI_Chat("Player "..rName.." Found, Adding.")
				RUI_Fav_List_Add(r)
			end
		end
	end
		
	RUI_Fav_Change = 1
end


function RUI_Fav_Get_UFrame_ID(fName)
	if not (fName) then return; end
	--"RUI_UFav_Header"
	local fNum = string.sub(fName, 16,17)
	if (fNum) then
		if (string.sub(fNum, 2,2)=="_") then
			fNum = string.sub(fNum, 1,1)
		end
		return tonumber(fNum)
	else
		return
	end
end

function RUI_Fav_Overlay_Click(self)
	if not (IsShiftKeyDown()) then return; end
	local FrameID = RUI_Get_UFrame_ID(self:GetName())
	if not (FrameID) then
		RUI_Chat("Error! Can't find Frame ID")
		return
	end
	
	if (not InCombatLockdown()) then
		local tName = RUI_Fav_List[FrameID] --UnitName(RUI_Unit[RUI_Fav[FrameID].UnitNumber].Unit)
		if (tName) then
			RUI_Chat("Removing "..tName.." from Favorites")
			RUI_Fav_List_Remove(tName)
		end
	else
		RUI_Chat("Can't Modify Favorites in Combat")
	end
end



function RUI_Fav_Up_Click(self)
	if (InCombatLockdown()) then
		RUI_Chat("Can't Modify Favorites in Combat")
		return;
	end
	
	local FrameID = RUI_Get_UFrame_ID(self:GetName())
	if not (FrameID) then
		RUI_Chat("Error! Can't find Frame ID")
		return
	end
	if (FrameID<=1) then return; end
	
	if not (IsShiftKeyDown()) then
		RUI_Fav_Swap(FrameID, FrameID-1)
	else
		RUI_Fav_MoveToTop(FrameID)
	end
end

function RUI_Fav_Down_Click(self)
	if (InCombatLockdown()) then
		RUI_Chat("Can't Modify Favorites in Combat")
		return;
	end

	local FrameID = RUI_Get_UFrame_ID(self:GetName())
	if not (FrameID) then
		RUI_Chat("Error! Can't find Frame ID")
		return
	end
	if (FrameID>=RUI_Num_Favs) then return; end
	if not (IsShiftKeyDown()) then
		RUI_Fav_Swap(FrameID, FrameID+1)
	else
		RUI_Fav_MoveToBottom(FrameID)
	end
end



--[[ ===========================================================================================================================
					UFRAME UPDATE FUNCTIONS 
=================================================================================================================================]]


function RUI_Refresh_Favs()
	if (RUI_Num_Favs<1) then return; end
	
	for f = 1, RUI_Num_Favs do
		if (RUI_Fav[f].Show) then
			RUI_Fav_Update_Health_Bar_Lite(f)
			if (RUI_FlipFlop) then
				-- If CheckRange and out of range Set UnDim Alpha to 0.5 if OOM
				if (RUI_Settings.CheckRange) and (RUI_Settings.RangeSpellName) then
					-- Check if unit is in range of spell
					--local tInRange = IsSpellInRange(RUI_Settings.RangeSpellName, RUI_Fav_List[f]) --RUI_Unit[RUI_Fav[f].UnitNumber].Unit) -- is nil for no valid target, 0 for out of range, 1 for in range
					local tInRange, checkedRange = UnitInRange(RUI_Fav_List[f])
					if (RUI_Fav[f].Header) then
						if  ((not checkedRange) or ((tInRange) and (tInRange==1))) then
							RUI_Fav[f].Header:SetAlpha(1)
						else
							RUI_Fav[f].Header:SetAlpha(0.3)
						end
					end
				end
				RUI_Fav_Set_Debuffs(f)
			end
		end
	end 
	if (RUI_FlipFlop) then
		RUI_Fav_Update_Buttons()
	end
end



--[[ ===========================================================================================================================
								HEALTH BAR AND MANA BAR FUNTIONS
=================================================================================================================================]]

--====================================== UPDATE HEALTH BARS ======================================================================
function RUI_Fav_Update_Health_Bar_Lite(tUFrame)
	local tHealth = nil
	if not (tUFrame) then return; end
	if not (RUI_Fav[tUFrame].Header) then return; end
	
	local RUI_tBarText = getglobal(RUI_Fav[tUFrame].Header:GetName().."_HealthBar_Text2")
	local RUI_tBar = getglobal(RUI_Fav[tUFrame].Header:GetName().."_HealthBar")
	if not (RUI_tBarText) or not (RUI_tBar) then return; end
	
	tUnit = RUI_Fav_List[tUFrame]
	if (tUnit) and ( UnitExists(tUnit) ) then
		tHealth = UnitHealth(tUnit)
		local tHealthPercent = nil
		
		if not (tHealth) then
			RUI_Chat("Error: No health for "..tUnit);
			RUI_tBar:SetValue(0);
			RUI_tBarText:SetText("");
			return;
		end
		
		if not (RUI_Fav[tUFrame].LastHealth) or (tHealth ~= RUI_Fav[tUFrame].LastHealth) then
			RUI_Fav[tUFrame].LastHealth = tHealth
			RUI_tBar:Show()
			if ( UnitIsCorpse(tUnit) or UnitIsDeadOrGhost(tUnit) ) then -- Target is dead, set bar to zero
				RUI_tBarText:SetText("Dead");
				RUI_tBar:SetValue(0);
				RUI_Fav_UFav_ClearStatus(tUFrame)
				RUI_Fav[tUFrame].LastHealth = tHealth
				RUI_Fav[tUFrame].IsDead = 1
			else -- Target is alive
				RUI_Fav[tUFrame].IsDead = nil
				RUI_tBarText:SetText("");
				local tMaxHealth = UnitHealthMax(tUnit)
				-- Calculate target's health percentage
				if (tMaxHealth == 100) then	-- Target's health already in percentages
					tHealthPercent = tHealth
				elseif (tMaxHealth > 0) then -- Target's health not in percentages
					local thingy = tHealth / tMaxHealth;
					thingy = thingy * 100;
					tHealthPercent = thingy;
				end
	
				if (tHealthPercent) then
					RUI_tBar:SetValue(tHealthPercent);
				end
				if (tHealthPercent) and (tHealthPercent>90) then
					RUI_tBar:SetStatusBarColor("0","1","0") -- Target is friendly set bar to green
				elseif (tHealthPercent) and (tHealthPercent>20) then
					RUI_tBar:SetStatusBarColor("1","1","0")
				else	
					RUI_tBar:SetStatusBarColor("1","0","0")
				end
			end -- else is alive
		end -- if health changed
	else -- else no unit
		RUI_tBar:SetValue(0);
		RUI_tBarText:SetText("");
	end
end




function RUI_Fav_SetFrame(tFavID)
	if not (tFavID) then return; end
	if not (RUI_Fav[tFavID].Header) then return; end
	-- Set HealthBar Values
	RUI_Fav[tFavID].LastHealth = 0 -- Last checked Health value, used to decide whether to update healthbar.	
	local tHB_Name_Text = getglobal(RUI_Fav[tFavID].Header:GetName() .. "_HealthBar_Text1");
	if (tHB_Name_Text) then 
		local tName = RUI_Fav_List[tFavID]
		if (tName) then
			tHB_Name_Text:SetText(tName)
			tHB_Name_Text:Show();
		else -- Don't show name test. Set it to blank and hide it.
			tHB_Name_Text:SetText("")
		end
	end
	RUI_Fav_Update_Health_Bar_Lite(tFavID)
	--SetAlpha
	if (RUI_Settings.CheckRange) and (RUI_Settings.RangeSpellName) then -- Check if unit is in range of spell
		tInRange = IsSpellInRange(RUI_Settings.RangeSpellName, RUI_Fav_List[tFavID]) --RUI_Unit[RUI_Fav[f].UnitNumber].Unit) -- is nil for no valid target, 0 for out of range, 1 for in range
		if  (tInRange) and (tInRange==1) then
			RUI_Fav[tFavID].Header:SetAlpha(1)
		else
			RUI_Fav[tFavID].Header:SetAlpha(0.3)
		end
	end
end


function RUI_Fav_SetFavoritesFrame()
	RUI_Unit_Frame_Height = 36 + 4 -- Calculate Unit Frame Height
	local tParent = getglobal("RUI_Favorites_Frame");
	tParent:SetHeight(RUI_Unit_Frame_Height * (RUI_Num_Favs) + 10)
	
	for f = 1, RUI_Max_Favs do
		if (f<=RUI_Num_Favs) then
			RUI_Fav[f].Show = 1 -- Whether the UFrame should be shown
			if (RUI_Fav[f].Header) then RUI_Fav[f].Header:Show(); end
		else
			RUI_Fav[f].Show = nil
			if (RUI_Fav[f].Header) then RUI_Fav[f].Header:Hide(); end
		end
	end
end


function RUI_Fav_UFav_ClearStatus(tUFrame)
	if not (tUFrame) then return; end
		
	RUI_Fav_ClearUFavButtons(tUFrame)
	
	RUI_Fav[tUFrame].HasCurse = nil
	RUI_Fav[tUFrame].HasDisease = nil
	RUI_Fav[tUFrame].HasPoison = nil
	RUI_Fav[tUFrame].HasMagic = nil
	RUI_Fav[tUFrame].HasWS = nil
	RUI_Fav[tUFrame].LastHealth = 0
end


--[[ ===========================================================================================================================
					Button and Header Functions
=================================================================================================================================]]
local RUI_Unit_Frame_Width = 100
local RUI_Unit_Frame_Height = 36

function RUI_Fav_Hide_Panel()
	if (RUI_Favorites_Frame) then -- Check if the header exist, if it exists then hide it.
		RUI_Favorites_Frame:SetAlpha(0);
	end
end

function RUI_Fav_Show_Panel()
	if (RUI_Favorites_Frame) then -- Check if the header exist, if it exists then hide it.
		RUI_Favorites_Frame:SetAlpha(1);
		RUI_Favorites_Frame:Show();
	end
end

--[[ ===========================================================================================================================

					CREATE FRAME AND BUTTON FUNCTIONS

					
					
					
=================================================================================================================================]]

--[[ ===========================================================================================================================
					Create Main Panel Functions
=================================================================================================================================]]


--=================================== CONFIGURE BUTTONS =========================================================================
function RUI_Fav_Config_Panel()
	-------- Set Panel Settings -----------------------
	if not (RUI_Settings.FavsEnable) then
		RUI_Fav_Header_Frame:Hide();
		return
	end
	RUI_Fav_Header_Frame:Show();
	RUI_Fav_Header_Frame:SetToplevel(1)
	local tPBackdrop = getglobal(RUI_Favorites_Frame:GetName() .. "Backdrop");
	if (tPBackdrop) then
		tPBackdrop:SetAlpha(0.75);
	end
		
	local tPadding = 186 -- Space for health bar
	RUI_Unit_Frame_Width = ((36 + 5)*RUI_Settings.NumberButtons)+tPadding + 4  -- Calculate Width of UFrames
	RUI_Unit_Frame_Height = 36 + 4 -- Calculate Unit Frame Height
	local tParent = getglobal("RUI_Favorites_Frame");
	tParent:SetScale(1);
	tParent:SetWidth(RUI_Unit_Frame_Width)
	tParent:SetScale(RUI_Settings.Scale);
	
	RUI_Fav_List_Update()
	
	for f = 1, RUI_Max_Favs do
		RUI_Fav_Config_UFrame(f)
		RUI_Fav[f].LastHealth = 0 -- Last checked Health value, used to decide whether to update healthbar.	
		if (f<=RUI_Num_Favs) then
			RUI_Fav[f].Show = 1 -- Whether the UFrame should be shown
			if (RUI_Fav[f].Header) then RUI_Fav[f].Header:Show(); end
		else
			RUI_Fav[f].Show = nil
			if (RUI_Fav[f].Header) then RUI_Fav[f].Header:Hide(); end
		end
	end
		
	tParent:SetHeight(RUI_Unit_Frame_Height * (RUI_Num_Favs) + 10)
	tParent:SetWidth(RUI_Unit_Frame_Width + 10)
		
	if (RUI_Settings.HideFavPanel) then
		RUI_Fav_Hide_Panel()
	else
		RUI_Fav_Show_Panel()
	end
end

--[[ ===========================================================================================================================
					Create UFrame Functions
=================================================================================================================================]]

--------------------------------CONFIG UNIT FRAME--------------------------------------------------------
function RUI_Fav_Config_UFrame(tUFrame)
	if not (tUFrame) then return; end
	
	local tParent = getglobal("RUI_Favorites_Frame");
	local tButton_Size = 36
	local tButton_Spacing = 5
	------ CONFIGURE HEADER --------------
	local hdr = RUI_Fav[tUFrame].Header; -- Fetch header handle
	if (not hdr) then -- Check if the header exist, if not create the header
		-- Create frame based on secure header template declared in RaidUI.xml
		hdr = CreateFrame("Frame", "RUI_UFav_Header"..tUFrame, tParent, "RUI_Fav_Unit_Template"); 
		hdr:SetParent("RUI_Party_Frame");
		hndlr = CreateFrame("Frame", hdr:GetName().."_SucHdr", hdr, "SecureHandlerStateTemplate")
		RUI_Fav[tUFrame].Header = hdr;
		RUI_Fav[tUFrame].Handler = hndlr;
	end
	hdr:SetParent("RUI_Party_Frame");
	
	local tVoffset = 0
	local tLabel = getglobal(hdr:GetName() .. "_Label");
	if (tLabel) then
		tLabel:Hide();
	end
		
	local tRow = tUFrame-1 -- - (tColumn * RUI_Settings.MaxRows)
	hdr:SetPoint("TOPLEFT", tParent, "TOPLEFT", 0, (-1*tRow*RUI_Unit_Frame_Height)-5);
	-- Set frame's height and width to fit number of buttons and name label
	hdr:SetWidth(RUI_Unit_Frame_Width);
	hdr:SetHeight(RUI_Unit_Frame_Height);
	
	local cOverlay = getglobal(hdr:GetName() .. "_HealthBar_ClickOverlay");
	--local fString = getglobal(hdr:GetName() .. "_HealthBar_Text1");
	--local hBar = getglobal(hdr:GetName() .. "_HealthBar");
	--hBar:SetToplevel(0)
	cOverlay:SetFrameLevel(hdr:GetFrameLevel() + 5);
	--cOverlay:SetToplevel(1)
	cOverlay:SetFrameStrata("TOOLTIP")
	
	local tHB_XPos = 10
	-- Set the Name text on healthbar
	local tHB_Name_Text = getglobal(hdr:GetName() .. "_HealthBar_Text1");
	if (tHB_Name_Text) then 
		-- Set the frame label to target unit's full name
		local tName = RUI_Fav_List[tUFrame] --UnitName(RUI_Unit[RUI_Fav[tUFrame].UnitNumber].Unit)
		if (tName) then
			tHB_Name_Text:SetText(tName)
			tHB_Name_Text:Show();
		else -- Don't show name test. Set it to blank and hide it.
			tHB_Name_Text:SetText("")
			tHB_Name_Text:Hide();
		end
		
		local HB = getglobal(hdr:GetName() .. "_HealthBar");			
		HB:Show();
		HB:SetFrameLevel(hdr:GetFrameLevel() + 1);
		HB:SetValue(0)
		RUI_Fav[tUFrame].LastHealth = 0
		local RUI_HB_Height = tButton_Size - 4 -- padding above HB(2) and below HB(2)
		HB:SetHeight(RUI_HB_Height)
		HB:SetPoint("LEFT", hdr, "LEFT", tHB_XPos, tVoffset);
	end
	ClearOverrideBindings(hdr); -- Clear any key bindings to buttons
		
	-- CONFIGURE SPELL BUTTONS ---------------
	local RUI_Button_Anchor = HB
	for i = 1, RUI_Max_Buttons do -- Cycle through all RUI_Max_Buttons possible buttons
		RUI_Fav_Config_Button(tUFrame, i, RUI_Button_Anchor)
		RUI_Button_Anchor = RUI_Fav[tUFrame].Button[i]
	end -- End for i loop (cycle through buttons)
	
	if (RUI_Fav[tUFrame].Show) then 
		hdr:Show();
	else
		hdr:Hide();
	end
	hndlr:SetAttribute("state", RUI_Button_CurrentState); -- Force a state refresh to update everthing
end

