--[[ ===========================================================================================================================
					Slash Command Handling Functions
=================================================================================================================================]]
local RUI_Menu_Select_State = nil
local RUI_Menu_Select_Button = nil



function RUI_Init_Slash()
-- Set up slash command hanler
	SLASH_RUIH1 = "/raidui";
	SLASH_RUIH2 = "/rui";
	SlashCmdList["RUIH"] = function (msg)
		RUI_SlashCmd(msg);
	end
end

function RUI_SlashCmd(arg, arg2)
		
	-- Show PartyTargets Config Menu
	if ( arg == "menu" ) then
		RUI_Menu_Load();
	end
		
	-- Initialize saved variables
	if ( arg == "init" ) then
		RUI_Init_Settings();
		DEFAULT_CHAT_FRAME:AddMessage("RaidUI: Initializing saved variables");
	end
	
	if ( arg == "saveprofile1" ) then
		RUI_Profile_Save(1)
	end
	if ( arg == "saveprofile2" ) then
		RUI_Profile_Save(2)
	end
	if ( arg == "saveprofile3" ) then
		RUI_Profile_Save(3)
	end
	if ( arg == "loadprofile1" ) then
		RUI_Profile_Load(1)
	end
	if ( arg == "loadprofile2" ) then
		RUI_Profile_Load(2)
	end
	if ( arg == "loadprofile3" ) then
		RUI_Profile_Load(3)
	end
	if ( arg == "initprofiles" ) then
		RUI_Chat("Wiping saved profiles")
		RUI_Profiles_Init()
	end
	
	if ( arg == "reset" ) then
		RUI_SpellChange = true;
	end
	
	if ( arg == "width" ) then
		RUI_Set_Width()
	end
	
	
	if ( arg == "rui" ) then
		ReloadUI()
	end
	
	
	-- Enable Debug Mode
	if ( arg == "debugon" ) then
		RUI_Settings.Debug = 1
		RUI_Chat("Debug Mode is now On")
	end
	
	-- Disable Debug Mode
	if ( arg == "debugoff" ) then
		RUI_Settings.Debug = nil
		RUI_Chat("Debug Mode is now Off")
	end
		
	if (arg=="") or ( arg == "help" ) then
		RUI_Chat("Available /rui Commands")
		RUI_Chat("menu - Loads RaidUI Menu")
		RUI_Chat("init - Initialize RaidUI Settings")
		RUI_Chat("loadprofile1 - Load Profile from slot (1-3)")
		RUI_Chat("saveprofile1 - Save Profile to slot (1-3)")
		RUI_Chat("initprofiles - Wipes saved profiles")
		RUI_Chat("rui - ReloadUI")
	end
end



--[[ ============================================================================
					Menu Handling Functions
=================================================================================]]


RUI_Menu_FriendBar=1;

RUI_SO_BarInfo = {}
RUI_SO_BarInfo.State = nil
RUI_SO_BarInfo.Button = nil



function RUI_Menu_ResetPosition_Click()
	local mFrame = getglobal("RUI_Header_Frame")
	if (mFrame) then
		mFrame:SetPoint("CENTER")
	end
	
	local fFrame = getglobal("RUI_Fav_Header_Frame")
	if (fFrame) then
		fFrame:SetPoint("CENTER")
	end
	
end


function RUI_Menu_ButtonSpell_Click(self)
	local tButtonName = self:GetName()
	local sb, se = string.find(tButtonName, "State")
	if (se) then
		bb, be = string.find(tButtonName, "Button")
		local but = nil
		if (be) then
			but = string.sub(tButtonName, be+1, sb-2)
		end
		if (but) then
			but = tonumber(but)
		end
		if (but) then
			--RUI_Chat("Buttons Menu - Button="..but.." State="..RUI_Settings.MenuState)
			RUI_Menu_Select_Button = but
			RUI_Menu_Update_SpellSelect_Frame()
			RUI_SelectSpell_Frame:Show()
			RUI_SelectSpell_Frame:SetPoint("TOPRIGHT", self , "TOPLEFT", 0, 0)
			RUI_SelectSpell_Frame:SetToplevel(1)
			RUI_SelectSpell_Frame:SetFrameLevel(RUI_Menu_Button1:GetFrameLevel() + 3);
			
		end
	end
		
	local ob, oe = string.find(tButtonName, "RUI_OptionSpell")
	if (oe) then
		local but = string.sub(tButtonName, oe+1)
		if (but) then
			but = tonumber(but)
		end
		if (but) then
			--RUI_Chat("Spell Option="..but.." Spell Name="..RUI_SpellList[but])
			if (RUI_Settings.MenuState) and (RUI_Menu_Select_Button) then
				RUI_MenuSpellState[RUI_Settings.MenuState].Button[RUI_Menu_Select_Button].SpellName = RUI_SpellList[but]
				--RUI_Chat("Setting Spell Name="..RUI_SpellList[but].." to State="..RUI_Menu_Select_State.."Button="..RUI_Menu_Select_Button)
				RUI_Show_Menu()
			end
		end
		RUI_Menu_Close_SpellSelect_Frame()
	end
end

function RUI_Menu_ButtonNoneSpell_Click()
	if (RUI_Settings.MenuState) and (RUI_Menu_Select_Button) then
		RUI_MenuSpellState[RUI_Settings.MenuState].Button[RUI_Menu_Select_Button].SpellName = nil
		RUI_Show_Menu()
	end
	RUI_Menu_Close_SpellSelect_Frame()
end


--================================== MENU TAB TOOlTIP FUNCTIONS ==============================================================================
function RUI_Menu_Tab1_Panel_ShowTooltip(self)
	GameTooltip:SetOwner(self, 'ANCHOR_BOTTOMRIGHT');
	GameTooltip:SetText("General Settings for RaidUI")
	GameTooltip:Show();
end
function RUI_Menu_Tab2_Panel_ShowTooltip(self)
	GameTooltip:SetOwner(self, 'ANCHOR_BOTTOMRIGHT');
	GameTooltip:SetText("RaidUI Panel appearance")
	GameTooltip:Show();
end
function RUI_Menu_Tab3_Panel_ShowTooltip(self)
	GameTooltip:SetOwner(self, 'ANCHOR_BOTTOMRIGHT');
	GameTooltip:SetText("Set what Units to show")
	GameTooltip:Show();
end
function RUI_Menu_Tab4_Panel_ShowTooltip(self)
	GameTooltip:SetOwner(self, 'ANCHOR_BOTTOMRIGHT');
	GameTooltip:SetText("Set button spells")
	GameTooltip:Show();
end
function RUI_Menu_Tab5_Panel_ShowTooltip(self)
	GameTooltip:SetOwner(self, 'ANCHOR_BOTTOMRIGHT');
	GameTooltip:SetText("Edit Spells and Spell Options")
	GameTooltip:Show();
end


--================================== MENU SPELL BUTTON FUNCTIONS ==============================================================================
function RUI_Menu_Button_ShowTooltip()

end

function RUI_Menu_SpellButton_OnClick()
	-- find _State
end



function RUI_Menu_Clear_SpellOptions(tType, tState, tButton)
	if not (tType) or (tType<0) or (tType>4) then return; end
	if not (tState) or (tState<0) or (tState>3) then return; end
	if not (tButton) or (tButton<1) or (tButton>RUI_Max_Buttons) then return; end
--[[	RUI_MenuSpellState[tState].Button[tButton].SpellID = nil
	RUI_MenuSpellState[tState].Button[tButton].SpellRank = nil
	RUI_MenuSpellState[tState].Button[tButton].UseMaxRank = nil
	RUI_MenuSpellState[tState].Button[tButton].SpellName = nil
	RUI_MenuSpellState[tState].Button[tButton].CheckIfActive = nil
	RUI_MenuSpellState[tState].Button[tButton].WeaponBuff = nil
	RUI_MenuSpellState[tState].Button[tButton].CheckDebuff = nil
	--RUI_MenuSpellState[tState].Button[tButton].DebuffType = nil
	RUI_MenuSpellState[tState].Button[tButton].DebuffType = nil
	RUI_MenuSpellState[tState].Button[tButton].DebuffMagic = nil
	RUI_MenuSpellState[tState].Button[tButton].DebuffCurse = nil
	RUI_MenuSpellState[tState].Button[tButton].DebuffPoison = nil
	RUI_MenuSpellState[tState].Button[tButton].DebuffDisease = nil
	RUI_MenuSpellState[tState].Button[tButton].DebuffWeakenedSoul = nil
	
	RUI_MenuSpellState[tState].Button[tButton].CheckTargetType = nil
	RUI_MenuSpellState[tState].Button[tButton].TargetType = nil
	RUI_MenuSpellState[tState].Button[tButton].CheckHeal = nil
	RUI_MenuSpellState[tState].Button[tButton].HealTrigger = nil
	RUI_MenuSpellState[tState].Button[tButton].Mana = nil
	RUI_MenuSpellState[tState].Button[tButton].HealMax = nil
	RUI_MenuSpellState[tState].Button[tButton].CheckRange = nil
	RUI_MenuSpellState[tState].Button[tButton].IsMeleeRange = nil
	RUI_MenuSpellState[tState].Button[tButton].SpellRange = nil]]
end

function RUI_Menu_Button_Click(arg1)

end

function RUI_Menu_Button_OnModifiedClick(drag) 

end

function RUI_Menu_Button_Update(arg1)
end

function RUI_Menu_Button_Init()

end

function RUI_Menu_Scale_Slider_OnLoad()
	RUI_Menu_Scale_Slider:SetMinMaxValues(0.5,1.5);
	RUI_Menu_Scale_Slider:SetValueStep(0.01);
end
function RUI_Menu_Scale_Slider_OnValueChanged()
	RUI_MenuSettings.Scale = RUI_Menu_Scale_Slider:GetValue();
	RUI_Menu_Scale_EditBox:SetText(RUI_MenuSettings.Scale)
end

function RUI_Menu_Scale_EditBox_OnValueChanged()
	local tScale = tonumber(RUI_Menu_Scale_EditBox:GetText())
	if (tScale) and (tScale>=0.5) and (tScale<=1.5) then
		RUI_MenuSettings.Scale = tScale
		RUI_Menu_Scale_Slider:SetValue(RUI_MenuSettings.Scale)
	else
		RUI_Menu_Scale_EditBox:SetText(RUI_MenuSettings.Scale)
	end
end

function RUI_Menu_UpdateInterval_EditBox_OnValueChanged()
	local tInterval = RUI_Menu_UpdateInterval_EditBox:GetNumber();
	if (tInterval) and (tInterval>=0) and (tInterval<=10000) then
		RUI_MenuSettings.UpdateInterval = tInterval
	else
		RUI_Menu_UpdateInterval_EditBox:SetText(RUI_MenuSettings.UpdateInterval)
	end
end
function RUI_Menu_UpdateInterval_EditBox_ClearValue()
	RUI_Menu_UpdateInterval_EditBox:SetText(RUI_MenuSettings.UpdateInterval)
end

function RUI_Menu_RangeSpell_EditBox_OnValueChanged()
	local tAlert = RUI_Menu_RangeSpell_EditBox:GetText();
	if (tAlert) then
		RUI_MenuSettings.RangeSpellName = tAlert
	else
		RUI_Menu_RangeSpell_EditBox:SetText(RUI_MenuSettings.RangeSpellName)
	end
end
function RUI_Menu_RangeSpell_EditBox_ClearValue()
	RUI_Menu_RangeSpell_EditBox:SetText(RUI_MenuSettings.RangeSpellName)
end


--================================== NUMBER OF BUTTONS FUNCTIONS ==============================================================================
function RUI_Menu_NumButtons_Slider_OnLoad()
	RUI_Menu_NumButtons_Slider:SetMinMaxValues(1,RUI_Max_Buttons);
	RUI_Menu_NumButtons_Slider:SetValueStep(1);
end
function RUI_Menu_NumButtons_Slider_OnValueChanged()
	RUI_MenuSettings.NumberButtons=RUI_Menu_NumButtons_Slider:GetValue();
	--RUI_Chat("Number Buttons="..RUI_MenuSettings.NumberButtons)
	RUI_Menu_NumButtons_EditBox:SetText(RUI_MenuSettings.NumberButtons)
	RUI_Show_Menu()
end
function RUI_Menu_NumButtons_EditBox_OnValueChanged()
	local tSize = tonumber(RUI_Menu_NumButtons_EditBox:GetText())
	
	if (tSize) and (tSize>=1) and (tSize<=RUI_Max_Buttons) then
		--RUI_Chat("Entered Number Buttons="..tSize)
		RUI_MenuSettings.NumberButtons= tSize
		RUI_Menu_NumButtons_Slider:SetValue(RUI_MenuSettings.NumberButtons)
		RUI_Show_Menu()
	else
		RUI_Menu_NumButtons_EditBox:SetText(RUI_MenuSettings.NumberButtons)
	end
end


--================================== Max Raid UFrame Slider FUNCTIONS ==============================================================================
function RUI_Menu_MaxRaidUFrames_Slider_OnLoad()
	RUI_Menu_MaxRaidUFrames_Slider:SetMinMaxValues(5,40);
	RUI_Menu_MaxRaidUFrames_Slider:SetValueStep(1);
end
function RUI_Menu_MaxRaidUFrames_Slider_OnValueChanged()
	RUI_MenuSettings.MaxRaidFrames=RUI_Menu_MaxRaidUFrames_Slider:GetValue();
	RUI_Menu_MaxRaidUFrames_EditBox:SetText(RUI_MenuSettings.MaxRaidFrames)
end

function RUI_Menu_MaxRaidUFrames_EditBox_OnValueChanged()
	local tMaxFrames = tonumber(RUI_Menu_MaxRaidUFrames_EditBox:GetText())
	if (tMaxFrames) and (tMaxFrames>=5) and (tMaxFrames<=40) then
		RUI_MenuSettings.MaxRaidFrames= tMaxFrames
		RUI_Menu_MaxRaidUFrames_EditBox:SetValue(RUI_MenuSettings.MaxRaidFrames)
	else
		RUI_Menu_MaxRaidUFrames_EditBox:SetText(RUI_MenuSettings.MaxRaidFrames)
	end
end


--================================== Max Rows Slider FUNCTIONS ==============================================================================
function RUI_Menu_MaxRows_Slider_OnLoad()
	RUI_Menu_MaxRows_Slider:SetMinMaxValues(5,25);
	RUI_Menu_MaxRows_Slider:SetValueStep(1);
end
function RUI_Menu_MaxRows_Slider_OnValueChanged()
	RUI_MenuSettings.MaxRows=RUI_Menu_MaxRows_Slider:GetValue();
	RUI_Menu_MaxRows_EditBox:SetText(RUI_MenuSettings.MaxRows)
end

function RUI_Menu_MaxRows_EditBox_OnValueChanged()
	local tMaxRows = tonumber(RUI_Menu_MaxRows_EditBox:GetText())
	if (tMaxRows) and (tMaxRows>=5) and (tMaxRows<=40) then
		RUI_MenuSettings.MaxRows = tMaxRows
		RUI_Menu_MaxRows_EditBox:SetValue(RUI_MenuSettings.MaxRows)
	else
		RUI_Menu_MaxRows_EditBox:SetText(RUI_MenuSettings.MaxRows)
	end
end







function RUI_Menu_GetButtonNumber(tName)
	--local tName = this:GetName();
	local tButton = nil
	if (tName) then
		-- RUI_Menu_ButtonOptions1
		tButton = string.sub(tName, 23)
		if (tButton) then
			tButton = tonumber(tButton)
		end
	end
	if (not tButton) or (tButton<1) or (tButton>RUI_Max_Buttons) then
		return;
	end
	return tButton;
end

function RUI_Menu_SpellName_EditBox_OnValueChanged(self)
	local b = RUI_Menu_GetButtonNumber(self:GetName())
	if (b) then
		RUI_MenuSpellState[RUI_Settings.MenuState].Button[b].SpellName = self:GetText();
	end
end
function RUI_Menu_SpellName_EditBox_ClearValue(self)
	local b = RUI_Menu_GetButtonNumber(self:GetName())
	if (b) then
		self:SetText(RUI_MenuSpellState[RUI_Settings.MenuState].Button[b].SpellName)
	end
end




function RUI_Menu_None_Button_Click()
	RUI_Settings.MenuState = 0
	RUI_Show_Menu()
end

function RUI_Menu_ALT_Button_Click()
	RUI_Settings.MenuState = 1
	RUI_Show_Menu()
end

function RUI_Menu_CTRL_Button_Click()
	RUI_Settings.MenuState = 2
	RUI_Show_Menu()
end

function RUI_Menu_Shift_Button_Click()
	RUI_Settings.MenuState = 3
	RUI_Show_Menu()
end


--================================== SHOW MENU ==============================================================================
function RUI_Show_Menu()
	RUI_Menu_Version:SetText("Version: "..RUI_Version)
	
	RUI_Menu_Close_SpellSelect_Frame()
	if not (RUI_Settings.MenuTab) or (RUI_Settings.MenuTab<1) or (RUI_Settings.MenuTab>5) then 
		-- Menu Tab Value Out of Range, set default
		RUI_Settings.MenuTab = 1
	end
	
	if not (RUI_Settings.MenuState) or (RUI_Settings.MenuState<0) or (RUI_Settings.MenuState>RUI_Max_State) then 
		RUI_Settings.MenuState = 0
	end
	
	if not(RUI_Settings.MenuTab==1) then -- Menu not General, Hide all General settings
		RUI_Tab_Frame1_Texture:SetAlpha(0.6);
		RUI_Tab_Frame1_Text:SetTextColor(0.5, 0.5, 0.5)
		RUI_Menu_Version_Lab:Hide();
		RUI_Menu_LockPanel_CheckButton:Hide();
		RUI_Menu_UpdateInterval_Frame:Hide();
		RUI_Menu_CheckRange_CheckButton:Hide();
		RUI_Menu_RangeSpell_Frame:Hide();
		RUI_Menu_DisableModifiers_CheckButton:Hide();
		RUI_Menu_FavEnable_CheckButton:Hide();
		RUI_Menu_Scale_Frame:Hide();
		RUI_Menu_ResetPosition_CheckButton:Hide();
	end
	if not(RUI_Settings.MenuTab==2) then -- Menu not Layout, Hide all Panel settings
		RUI_Tab_Frame2_Texture:SetAlpha(0.6);
		RUI_Tab_Frame2_Text:SetTextColor(0.5, 0.5, 0.5)
		RUI_Menu_MaxRaidUFrames_Frame:Hide();
		RUI_Menu_MaxRows_Frame:Hide();
		RUI_Menu_Profile_Frame:Hide()
	end
	if not(RUI_Settings.MenuTab==3) then -- Menu not Unit Menu, Hide all Menu settings
		RUI_Tab_Frame3_Texture:SetAlpha(0.6);
		RUI_Tab_Frame3_Text:SetTextColor(0.5, 0.5, 0.5)
		RUI_BM_Background:Hide();
		RUI_Menu_NumButtons_Frame:Hide();
		RUI_Menu_StateButtons_Frame:Hide();
		for b=1, RUI_Max_Buttons do
			getglobal("RUI_Menu_Button"..b):Hide();
		end		
	end
	
	---------------- SHOW GENRAL TAB -------------------------------------------------
	if (RUI_Settings.MenuTab==1) then
		-- Menu is General, Show and set all General settings
		RUI_Menu_Version_Lab:SetText("RaidUI Version: ".. RUI_Version);
		RUI_Menu_Version_Lab:Show();
		-- Load Menu Tab Enabled Texture
		RUI_Tab_Frame1_Texture:SetAlpha(1);
		RUI_Tab_Frame1_Text:SetTextColor(1, 1, 0)
		-- Set Lock Panel
		RUI_Menu_LockPanel_CheckButton:Show();
		if ( RUI_MenuSettings.LockPanel ) then
			getglobal("RUI_Menu_LockPanel_CheckButton"):SetChecked( 1 );
		else
			getglobal("RUI_Menu_LockPanel_CheckButton"):SetChecked( nil );
		end
		-- Set Update Interval Timer
		RUI_Menu_UpdateInterval_Frame:Show();
		--RUI_Menu_UpdateInterval_Lab:Show();
		--RUI_Menu_UpdateInterval_EditBox:Show();
		RUI_Menu_UpdateInterval_EditBox:SetText(RUI_MenuSettings.UpdateInterval)
			
		RUI_Menu_CheckRange_CheckButton:Show();
		if ( RUI_MenuSettings.CheckRange ) then
			getglobal("RUI_Menu_CheckRange_CheckButton"):SetChecked( 1 );
		else
			getglobal("RUI_Menu_CheckRange_CheckButton"):SetChecked( nil );
		end
		RUI_Menu_RangeSpell_Frame:Show();
		
		RUI_Menu_DisableModifiers_CheckButton:Show();
		if ( RUI_MenuSettings.DisableModifiers ) then
			getglobal("RUI_Menu_DisableModifiers_CheckButton"):SetChecked( 1 );
		else
			getglobal("RUI_Menu_DisableModifiers_CheckButton"):SetChecked( nil );
		end
		
		RUI_Menu_FavEnable_CheckButton:Show();
		if ( RUI_MenuSettings.FavsEnable ) then
			getglobal("RUI_Menu_FavEnable_CheckButton"):SetChecked( 1 );
		else
			getglobal("RUI_Menu_FavEnable_CheckButton"):SetChecked( nil );
		end
		-- Set slider psoitions on all sliders
		RUI_Menu_Scale_Frame:Show()
		RUI_Menu_Scale_Slider:SetValue(RUI_MenuSettings.Scale)
		RUI_Menu_Scale_EditBox:SetText(RUI_MenuSettings.Scale)
						
		RUI_Menu_ResetPosition_CheckButton:Show();
	end
	------------------ SHOW LAYOUT TAB ----------------------------------------------------------
	if (RUI_Settings.MenuTab==2) then
		-- Menu is Panel, Show and set all Panel settings
		-- Load Menu Tab Enabled Texture
		RUI_Tab_Frame2_Texture:SetAlpha(1);
		RUI_Tab_Frame2_Text:SetTextColor(1, 1, 0)
		
		--RUI_Menu_MaxRaidUFrames_Frame:SetAlpha(1);
		--RUI_Menu_MaxRaidUFrames_Slider:Enable();
		--RUI_Menu_MaxRows_Frame:SetAlpha(1);
		--RUI_Menu_MaxRows_Slider:Enable();
		
		RUI_Menu_MaxRaidUFrames_Frame:Show();
		RUI_Menu_MaxRaidUFrames_Lab:Show();
		RUI_Menu_MaxRaidUFrames_Slider:Show();
		RUI_Menu_MaxRaidUFrames_EditBox:Show();
		RUI_Menu_MaxRaidUFrames_Slider:SetValue(RUI_MenuSettings.MaxRaidFrames)
		RUI_Menu_MaxRaidUFrames_EditBox:SetText(RUI_MenuSettings.MaxRaidFrames)
		
		RUI_Menu_MaxRows_Frame:Show();
		RUI_Menu_MaxRows_Slider:SetValue(RUI_MenuSettings.MaxRows)
		RUI_Menu_MaxRows_EditBox:SetText(RUI_MenuSettings.MaxRows)
		
		RUI_Menu_Profile_Frame:Show()
	end
	---------------------- SHOW BUTTONS TAB ----------------------------------
	if (RUI_Settings.MenuTab==3) then
		-- Menu is Menu, Show and set all Menu settings
		-- Load Menu Tab Enabled Texture
		RUI_Tab_Frame3_Texture:SetAlpha(1);
		RUI_Tab_Frame3_Text:SetTextColor(1, 1, 0)
		-- Show Buttons Menu background and Tabs
		RUI_BM_Background:Show();
		-- Set Unit Tab Textures
		
		RUI_Menu_NumButtons_Frame:Show();
		RUI_Menu_NumButtons_Slider:SetValue(RUI_MenuSettings.NumberButtons)
		RUI_Menu_NumButtons_EditBox:SetText(RUI_MenuSettings.NumberButtons)
		
		RUI_Menu_StateButtons_Frame:Show();
		if (RUI_Settings.MenuState==0) then
			RUI_Menu_None_Button:Show()
			RUI_Menu_None_GrayButton:Hide()
		else
			RUI_Menu_None_Button:Hide()
			RUI_Menu_None_GrayButton:Show()
		end
		if (RUI_Settings.MenuState==1) then
			RUI_Menu_ALT_Button:Show()
			RUI_Menu_ALT_GrayButton:Hide()
		else
			RUI_Menu_ALT_Button:Hide()
			RUI_Menu_ALT_GrayButton:Show()
		end
		if (RUI_Settings.MenuState==2) then
			RUI_Menu_CTRL_Button:Show()
			RUI_Menu_CTRL_GrayButton:Hide()
		else
			RUI_Menu_CTRL_Button:Hide()
			RUI_Menu_CTRL_GrayButton:Show()
		end
		if (RUI_Settings.MenuState==3) then
			RUI_Menu_Shift_Button:Show()
			RUI_Menu_Shift_GrayButton:Hide()
		else
			RUI_Menu_Shift_Button:Hide()
			RUI_Menu_Shift_GrayButton:Show()
		end
				
		for b=1, RUI_Max_Buttons do
			if (b<=RUI_MenuSettings.NumberButtons) then
				getglobal("RUI_Menu_Button"..b):Show();
				getglobal("RUI_Menu_Button"..b.."_Lab"):SetText("Button "..b);
				if (RUI_MenuSpellState[RUI_Settings.MenuState].Button[b].SpellName) then -- Spell Name
					getglobal("RUI_Menu_Button"..b.."_State_SpellName"):SetText(RUI_MenuSpellState[RUI_Settings.MenuState].Button[b].SpellName);
					getglobal("RUI_Menu_Button"..b.."_State_SpellTexture"):SetTexture(GetSpellTexture(RUI_MenuSpellState[RUI_Settings.MenuState].Button[b].SpellName));
				else
					getglobal("RUI_Menu_Button"..b.."_State_SpellName"):SetText("");
					getglobal("RUI_Menu_Button"..b.."_State_SpellTexture"):SetTexture(nil);
				end				
			else
				getglobal("RUI_Menu_Button"..b):Hide();
			end
		end
	end
	
end

--================================== STORE MENU ==============================================================================
function RUI_Store_Menu()
	if not (RUI_Settings.MenuTab) or (RUI_Settings.MenuTab<1) or (RUI_Settings.MenuTab>5) then return; end

	------------------- COPY GENERAL TAB TO MENU SETTINGS ---------------------------------
	if (RUI_Settings.MenuTab==1) then
		RUI_MenuSettings.LockPanel = RUI_Menu_LockPanel_CheckButton:GetChecked()
		RUI_MenuSettings.DisableModifiers = RUI_Menu_DisableModifiers_CheckButton:GetChecked()
		RUI_MenuSettings.FavsEnable = RUI_Menu_FavEnable_CheckButton:GetChecked()
	end
end

--================================== MENU SPELL BAR TYPE BUTTONS ==============================================================================
function RUI_Menu_Update_Page()
	RUI_Store_Menu()
	RUI_Show_Menu()
end

function RUI_Tab_Frame1_Click()
	if (RUI_Settings.MenuTab==1) then return; end
	RUI_Store_Menu()
	RUI_Settings.MenuTab = 1
	RUI_Show_Menu()
end
function RUI_Tab_Frame2_Click()
	if (RUI_Settings.MenuTab==2) then return; end
	RUI_Store_Menu()
	RUI_Settings.MenuTab = 2
	RUI_Show_Menu()
end
function RUI_Tab_Frame3_Click()
	if (RUI_Settings.MenuTab==3) then return; end
	RUI_Store_Menu()
	RUI_Settings.MenuTab = 3
	RUI_Show_Menu()
end


--================================== MENU OPEN AND CLOSE FUNCTION ==============================================================================
function RUI_Menu_Ok()
	-- Store current menu
	RUI_Store_Menu()
	-- Save changes to Player 
	RUI_Menu_SaveToPlayer()
	-- Hide Menu
	if ( RUI_Menu_Frame:IsVisible() ) then 
		PlaySound("igMainMenuClose");
		RUI_Menu_Frame:Hide();
		RUI_Menu_Close_SpellSelect_Frame()
	end
	-- Set pending change so next available chance, the buttons will update
	RUI_SpellChange = true;
	RUI_FrameOnEvent()
	
	if (RUI_Settings.UpdateInterval) then
		local tInterval = RUI_Settings.UpdateInterval/1000
		RUI_Set_Update_Timer(tInterval)
	end
end

function RUI_Menu_Cancel()
	-- Hide Menu and ignore changes
	if ( RUI_Menu_Frame:IsVisible() ) then 
		PlaySound("igMainMenuClose");
		RUI_Menu_Frame:Hide();
		RUI_Menu_Close_SpellSelect_Frame()
	end
end

function RUI_Menu_Load()
	DEFAULT_CHAT_FRAME:AddMessage("RaidUI: Loadeding Menu");
	-- Load current player settings to a menu temp variable
	RUI_Menu_LoadFromPlayer()
	if ( not RUI_Menu_Frame:IsVisible() ) then 
		PlaySound("igMainMenuOpen");
		RUI_Menu_Frame:Show();
	end
	RUI_Show_Menu()
end

--================================== MENU SAVE AND LOAD FUNCTIONS ==============================================================================
function RUI_Menu_SaveToPlayer()
	RUI_Settings.LockPanel = RUI_MenuSettings.LockPanel
	RUI_Settings.UpdateInterval = RUI_MenuSettings.UpdateInterval
	RUI_Settings.Scale = RUI_MenuSettings.Scale
	RUI_Settings.NumberButtons = RUI_MenuSettings.NumberButtons
	RUI_Settings.MaxRaidFrames = RUI_MenuSettings.MaxRaidFrames
	RUI_Settings.MaxRows = RUI_MenuSettings.MaxRows
	RUI_Settings.CheckRange = RUI_MenuSettings.CheckRange
	RUI_Settings.RangeSpellName = RUI_MenuSettings.RangeSpellName
	RUI_Settings.DisableModifiers = RUI_MenuSettings.DisableModifiers
	RUI_Settings.FavsEnable = RUI_MenuSettings.FavsEnable
		
	for s=0, RUI_Max_State do	-- Button States
		for b = 1, RUI_Max_Buttons do
			RUI_SpellState[s].Button[b].SpellName = RUI_MenuSpellState[s].Button[b].SpellName
		end
	end
		
	local i = 1
	while (RUI_MenuSpellList[i]) do
		RUI_SpellList[i] = RUI_MenuSpellList[i]
		if (RUI_MenuSpellOptions[RUI_MenuSpellList[i]]) then
			RUI_SpellOptions[RUI_SpellList[i]] = {}
			RUI_SpellOptions[RUI_SpellList[i]].SpellName = RUI_MenuSpellOptions[RUI_MenuSpellList[i]].SpellName
			RUI_SpellOptions[RUI_SpellList[i]].CheckIfActive = RUI_MenuSpellOptions[RUI_MenuSpellList[i]].CheckIfActive
			RUI_SpellOptions[RUI_SpellList[i]].WeaponBuff = RUI_MenuSpellOptions[RUI_MenuSpellList[i]].WeaponBuff
			RUI_SpellOptions[RUI_SpellList[i]].WearOffAlert = RUI_MenuSpellOptions[RUI_MenuSpellList[i]].WearOffAlert
			RUI_SpellOptions[RUI_SpellList[i]].CheckDebuff = RUI_MenuSpellOptions[RUI_MenuSpellList[i]].CheckDebuff
			RUI_SpellOptions[RUI_SpellList[i]].DebuffMagic = RUI_MenuSpellOptions[RUI_MenuSpellList[i]].DebuffMagic
			RUI_SpellOptions[RUI_SpellList[i]].DebuffCurse = RUI_MenuSpellOptions[RUI_MenuSpellList[i]].DebuffCurse
			RUI_SpellOptions[RUI_SpellList[i]].DebuffPoison = RUI_MenuSpellOptions[RUI_MenuSpellList[i]].DebuffPoison
			RUI_SpellOptions[RUI_SpellList[i]].DebuffDisease = RUI_MenuSpellOptions[RUI_MenuSpellList[i]].DebuffDisease
			RUI_SpellOptions[RUI_SpellList[i]].DebuffWeakenedSoul = RUI_MenuSpellOptions[RUI_MenuSpellList[i]].DebuffWeakenedSoul
		end
		i=i+1
	end
end

function RUI_Menu_LoadFromPlayer()
	RUI_MenuSettings.LockPanel = RUI_Settings.LockPanel
	RUI_MenuSettings.UpdateInterval = RUI_Settings.UpdateInterval
	RUI_MenuSettings.Scale = RUI_Settings.Scale
	RUI_MenuSettings.NumberButtons = RUI_Settings.NumberButtons
	RUI_MenuSettings.MaxRaidFrames = RUI_Settings.MaxRaidFrames
	RUI_MenuSettings.MaxRows = RUI_Settings.MaxRows
	RUI_MenuSettings.CheckRange = RUI_Settings.CheckRange
	RUI_MenuSettings.RangeSpellName = RUI_Settings.RangeSpellName
	RUI_MenuSettings.DisableModifiers = RUI_Settings.DisableModifiers
	
	RUI_MenuSettings.FavsEnable = RUI_Settings.FavsEnable
	
	for s=0, RUI_Max_State do	-- Button States
		for b = 1, RUI_Max_Buttons do
			RUI_MenuSpellState[s].Button[b].SpellName = RUI_SpellState[s].Button[b].SpellName
		end
	end
		
	local i = 1
	while (RUI_SpellList[i]) do
		RUI_MenuSpellList[i] = RUI_SpellList[i]
		if (RUI_SpellOptions[RUI_SpellList[i]]) then
			RUI_MenuSpellOptions[RUI_MenuSpellList[i]] = {}
			RUI_MenuSpellOptions[RUI_MenuSpellList[i]].SpellName = RUI_SpellOptions[RUI_SpellList[i]].SpellName
			RUI_MenuSpellOptions[RUI_MenuSpellList[i]].CheckIfActive = RUI_SpellOptions[RUI_SpellList[i]].CheckIfActive
			RUI_MenuSpellOptions[RUI_MenuSpellList[i]].WeaponBuff = RUI_SpellOptions[RUI_SpellList[i]].WeaponBuff
			RUI_MenuSpellOptions[RUI_MenuSpellList[i]].WearOffAlert = RUI_SpellOptions[RUI_SpellList[i]].WearOffAlert
			RUI_MenuSpellOptions[RUI_MenuSpellList[i]].CheckDebuff = RUI_SpellOptions[RUI_SpellList[i]].CheckDebuff
			RUI_MenuSpellOptions[RUI_MenuSpellList[i]].DebuffMagic = RUI_SpellOptions[RUI_SpellList[i]].DebuffMagic
			RUI_MenuSpellOptions[RUI_MenuSpellList[i]].DebuffCurse = RUI_SpellOptions[RUI_SpellList[i]].DebuffCurse
			RUI_MenuSpellOptions[RUI_MenuSpellList[i]].DebuffPoison = RUI_SpellOptions[RUI_SpellList[i]].DebuffPoison
			RUI_MenuSpellOptions[RUI_MenuSpellList[i]].DebuffDisease = RUI_SpellOptions[RUI_SpellList[i]].DebuffDisease
			RUI_MenuSpellOptions[RUI_MenuSpellList[i]].DebuffWeakenedSoul = RUI_SpellOptions[RUI_SpellList[i]].DebuffWeakenedSoul
		end
		i=i+1
	end
	
end

function RUI_Menu_SetPosition_Click()
	RUI_Reset_All_HeaderPositions();
end


--[[ ===========================================================================================================================
					Button and Header Functions
=================================================================================================================================]]

function RUI_Menu_Close_SpellSelect_Frame()
	RUI_SelectSpell_Frame:Hide()
	RUI_Menu_Select_State = nil
	RUI_Menu_Select_Button = nil
end

function RUI_Menu_Update_SpellSelect_Frame()
	for i=1, 40 do
		if (RUI_SpellList[i]) then		
			getglobal(RUI_Menu_SpellOption[i]:GetName().."_SpellName"):SetText(RUI_SpellList[i])
			getglobal(RUI_Menu_SpellOption[i]:GetName().."_SpellTexture"):SetTexture(GetSpellTexture(RUI_SpellList[i]))
			RUI_Menu_SpellOption[i]:Show()
		else
			RUI_Menu_SpellOption[i]:Hide()
		end
	end
end

function RUI_Menu_Create_SpellSelect_Frame()
	tParent = getglobal("RUI_SelectSpell_Frame")
	local ssfWidth = 140
	for i=1, 40 do
		if not (RUI_Menu_SpellOption[i]) then -- Create Option Frame (SpellButton Frame)
			RUI_Menu_SpellOption[i] = CreateFrame("Button", "RUI_OptionSpell"..i, tParent, "RUI_Menu_SpellButton_Template")
		end
					
		local xoff = 5
		local yoff = 0
		if (i<=10) then
			yoff = ((i-1)*-20) - 5
		elseif (i<=20) then
			yoff = ((i-11)*-20) - 5
			xoff = 137
		elseif (i<=30) then
			yoff = ((i-21)*-20) - 5
			xoff = 269
		else
			yoff = ((i-31)*-20) - 5
			xoff = 401
		end
		
		if (RUI_SpellList[i]) then
			if (i<=10) then
				ssfWidth = 140
			elseif (i<=20) then
				ssfWidth = 272
			elseif (i<=30) then
				ssfWidth = 404
			else
				ssfWidth = 536
			end
		end
		
		RUI_Menu_SpellOption[i]:SetPoint("TOPLEFT", tParent , "TOPLEFT", xoff, yoff)
	end
	RUI_Menu_Update_SpellSelect_Frame()
	tParent:SetFrameLevel(RUI_Menu_Button1:GetFrameLevel() + 3); --RUI_Menu_Frame
	tParent:SetScale(1);
	tParent:SetWidth(ssfWidth)
	--RUI_Chat("Select Spell Frame="..ssfWidth)
	tParent:Hide()
end

function RUI_Menu_Profile_Save_Button1_Click()
	RUI_Store_Menu()
	RUI_Menu_SaveToPlayer()
	RUI_SpellChange = true;
	RUI_Profile_Save(1)
end
function RUI_Menu_Profile_Load_Button1_Click()
	RUI_Profile_Load(1)
	RUI_Config_Panels();
	RUI_Update_Buttons()
	RUI_Fav_Config_Panel()
	RUI_Fav_Update_Buttons()
	RUI_Menu_LoadFromPlayer()
	RUI_Show_Menu()
end
function RUI_Menu_Profile_Save_Button2_Click()
	RUI_Store_Menu()
	RUI_Menu_SaveToPlayer()
	RUI_SpellChange = true;
	RUI_Profile_Save(2)
end
function RUI_Menu_Profile_Load_Button2_Click()
	RUI_Profile_Load(2)
	RUI_Config_Panels();
	RUI_Update_Buttons()
	RUI_Fav_Config_Panel()
	RUI_Fav_Update_Buttons()
	RUI_Menu_LoadFromPlayer()
	RUI_Menu_LoadFromPlayer()
	RUI_Show_Menu()
end
function RUI_Menu_Profile_Save_Button3_Click()
	RUI_Store_Menu()
	RUI_Menu_SaveToPlayer()
	RUI_SpellChange = true;
	RUI_Profile_Save(3)
end
function RUI_Menu_Profile_Load_Button3_Click()
	RUI_Profile_Load(3)
	RUI_Config_Panels();
	RUI_Update_Buttons()
	RUI_Fav_Config_Panel()
	RUI_Fav_Update_Buttons()
	RUI_Menu_LoadFromPlayer()
	RUI_Menu_LoadFromPlayer()
	RUI_Show_Menu()
end
