--[[-----------------------------------------------------------------------------------------------------------------------------
Class Spells
These functions list the useable spells for each class and sets whether they are enabled.
---------------------------------------------------------------------------------------------------------------------------------]]

function RUI_Profiles_Init()
	for p=1,3 do
		RUI_Profile[p] = {}
		RUI_Profile[p].NumButtons = 4
		RUI_Profile[p].SpellState = {}
		for s=0, 3 do
			RUI_Profile[p].SpellState[s] = {}
			RUI_Profile[p].SpellState[s].Button = {}
			for b=1, 12 do
				RUI_Profile[p].SpellState[s].Button[b] = {}
				RUI_Profile[p].SpellState[s].Button[b].SpellName = nil
			end
		end
	end
end

function RUI_Profile_Save(pSlot)
	if not (pSlot) or (pSlot<1) or (pSlot>3) then return; end
	RUI_Chat("Saving Profile "..pSlot)
	for s=0, 3 do
		for b=1, 12 do
			RUI_Profile[pSlot].SpellState[s].Button[b].SpellName = RUI_SpellState[s].Button[b].SpellName
		end
	end
	RUI_Profile[pSlot].NumButtons = RUI_Settings.NumberButtons
end

function RUI_Profile_Load(pSlot)
	if not (pSlot) or (pSlot<1) or (pSlot>3) then return; end
	RUI_Chat("Loading Profile "..pSlot)
	for s=0, 3 do
		for b=1, 12 do
			RUI_SpellState[s].Button[b].SpellName = RUI_Profile[pSlot].SpellState[s].Button[b].SpellName
		end
	end
	RUI_Settings.NumberButtons = RUI_Profile[pSlot].NumButtons
	RUI_SpellChange = true;
end


