function RUI_Min_Click()
	RUI_Hide_Panel()
	RUI_Settings.HidePanel = 1
end

function RUI_Max_Click()
	RUI_Show_Panel()
	RUI_Settings.HidePanel = nil
end

function RUI_Hide_Header()
	RUI_Header_Frame:Hide()
end
function RUI_Show_Header()
	RUI_Header_Frame:Show()
end


function RUI_Get_UFrame_ID(fName)
	if not (fName) then return; end
	--"RUI_Unit_Header"
	local fNum = string.sub(fName, 16,17)
	if (fNum) then
		if (string.sub(fNum, 2,2)=="_") then
			fNum = string.sub(fNum, 1,1)
		end
		return tonumber(fNum)
	else
		return
	end
end

function RUI_Overlay_Click(self)
	if not (IsShiftKeyDown()) then return; end
	local FrameID = RUI_Get_UFrame_ID(self:GetName())
	if not (FrameID) then
		RUI_Chat("Error! Can't find Frame ID")
		return
	end
	
	if (not InCombatLockdown()) then
		RUI_Fav_List_Add(FrameID)
	else
		RUI_Chat("Can't Add Favorites in Combat")
	end
end


--[[ ===========================================================================================================================

					RaidUI FRAME AND BUTTON REFRESH FUNCTIONS
					
					
=================================================================================================================================]]

function RUI_Reset_All_HeaderPositions()
	-- Recenter Header
	RUI_Header_Frame:SetPoint("RIGHT", "UIParent", "RIGHT", -200, 0);
	RUI_Fav_Header_Frame:SetPoint("RIGHT", "UIParent", "RIGHT", -400, 0);
end


--[[ ===========================================================================================================================
					UFRAME UPDATE FUNCTIONS 
=================================================================================================================================]]

function RUI_Refresh_UFrames()
	for f = 0, RUI_Num_UFrames do
		if (RUI_UFrame[f].Show) and not (RUI_UFrame[f].IsFavorite) then --if (RUI_UFrame[f].Show) then
			RUI_Update_Health_Bar_Lite(f)
			if (RUI_FlipFlop) then
				-- If CheckRange and out of range Set UnDim Alpha to 0.5 if OOM
				if  (RUI_Settings.CheckRange) and (RUI_Settings.RangeSpellName) then --not (f==0) and
					-- Check if unit is in range of spell
					--local tInRange = IsSpellInRange(RUI_Settings.RangeSpellName, RUI_Unit[RUI_UFrame[f].UnitNumber].Unit) -- is nil for no valid target, 0 for out of range, 1 for in range
					local tInRange, checkedRange = UnitInRange(RUI_Unit[RUI_UFrame[f].UnitNumber].Unit);
					if (RUI_UFrame[f].Header) then
						if  ((not checkedRange) or ((tInRange) and (tInRange==1))) then
							RUI_UFrame[f].Header:SetAlpha(1)
						else
							RUI_UFrame[f].Header:SetAlpha(0.3)
						end
					end
				end
				RUI_Set_Debuffs(f)
			end
		end
	end 
	if (RUI_FlipFlop) then
		RUI_Update_Buttons()
	end
end



--[[ ===========================================================================================================================
								HEALTH BAR AND MANA BAR FUNTIONS
=================================================================================================================================]]

--====================================== UPDATE HEALTH BARS ======================================================================
function RUI_Update_Health_Bar_Lite(tUFrame)
	local tHealth = nil
	if not (tUFrame) then return; end
	if not (RUI_UFrame[tUFrame].Header) then return; end
	
	local RUI_tBarText = getglobal(RUI_UFrame[tUFrame].Header:GetName().."_HealthBar_Text2")
	local RUI_tBar = getglobal(RUI_UFrame[tUFrame].Header:GetName().."_HealthBar")
			
	tUnit = RUI_Unit[RUI_UFrame[tUFrame].UnitNumber].Unit
	if (tUnit) and ( UnitName(tUnit) ) then
		tHealth = UnitHealth(tUnit)
		local tHealthPercent = nil
		
		if not (tHealth) then
			RUI_tBar:SetValue(0);
			RUI_tBarText:SetText("");
			return;
		end
		if not (RUI_UFrame[tUFrame].LastHealth) or (tHealth ~= RUI_UFrame[tUFrame].LastHealth) then
			
			RUI_UFrame[tUFrame].LastHealth = tHealth
			if (RUI_tBarText) and (RUI_tBar) then 
				RUI_tBar:Show()
				if ( UnitIsCorpse(tUnit) or UnitIsDeadOrGhost(tUnit) ) then -- Target is dead, set bar to zero
					RUI_tBarText:SetText("Dead");
					RUI_tBar:SetValue(0);
					RUI_UFrame_ClearStatus(tUFrame)
					RUI_UFrame[tUFrame].LastHealth = tHealth
					RUI_UFrame[tUFrame].IsDead = 1
				else -- Target is alive
					RUI_UFrame[tUFrame].IsDead = nil
					RUI_tBarText:SetText("");
					local tMaxHealth = UnitHealthMax(tUnit)
					-- Calculate target's health percentage
					if (tMaxHealth == 100) then	-- Target's health already in percentages
						tHealthPercent = tHealth
					elseif (tMaxHealth > 0) then -- Target's health not in percentages
						local thingy = tHealth / tMaxHealth;
						thingy = thingy * 100;
						tHealthPercent = thingy;
					end
					if (tHealthPercent) then
						RUI_tBar:SetValue(tHealthPercent);
					end
		
					if (tHealthPercent) and (tHealthPercent>90) then
						RUI_tBar:SetStatusBarColor("0","1","0")
					elseif (tHealthPercent) and (tHealthPercent>20) then
						RUI_tBar:SetStatusBarColor("1","1","0")
					else	
						RUI_tBar:SetStatusBarColor("1","0","0")
					end
				end -- else is alive
			end -- Bar and text not found
		end -- if health changed
	else -- else no unit
		RUI_tBar:SetValue(0);
		RUI_tBarText:SetText("");
	end
end

function RUI_UFrame_ClearStatus(tUFrame)
	if not (tUFrame) then return; end
	
	RUI_UFrame_ClearButtons(tUFrame)
	
	RUI_UFrame[tUFrame].HasCurse = nil
	RUI_UFrame[tUFrame].HasDisease = nil
	RUI_UFrame[tUFrame].HasPoison = nil
	RUI_UFrame[tUFrame].HasMagic = nil
	RUI_UFrame[tUFrame].HasWS = nil
	RUI_UFrame[tUFrame].LastHealth = 0
end

function RUI_UFrame_SetAsFavorite(tUFrame)
	if not (tUFrame) then return; end
	
	RUI_UFrame[tUFrame].IsFavorite = 1
	if (RUI_UFrame[tUFrame].Header) then
		RUI_UFrame[tUFrame].Header:SetAlpha(0.1)
		local RUI_tBar = getglobal(RUI_UFrame[tUFrame].Header:GetName().."_HealthBar")
		if (RUI_tBar) then 
			RUI_tBar:SetValue(0);
		end
	end
	RUI_UFrame_ClearStatus(tUFrame)
end

function RUI_UFrames_DimFavorite_UFrame(tUFrame)
	if not (tUFrame) then return; end
	
	if (RUI_UFrame[tUFrame].Header) then
		if (RUI_UFrame[tUFrame].IsFavorite) then
			RUI_UFrame[tUFrame].Header:SetAlpha(0.1)
			local RUI_tBar = getglobal(RUI_UFrame[tUFrame].Header:GetName().."_HealthBar")
			if (RUI_tBar) then 
				RUI_tBar:SetValue(0);
			end
		end
	end
	
end

function RUI_UFrames_DimFavorites()
	for f = 0, RUI_Num_UFrames do
		RUI_UFrames_DimFavorite_UFrame(f)
	end
	RUI_Refresh_UFrames()
end



