--[[--------------------------------------------------------------------------------------------------------------------------------- 
Find Spell ID Functions
Spell IDs are need to get spell button textures and cool downs.
---------------------------------------------------------------------------------------------------------------------------------]]

function RUI_Chat(msg)
	if msg==nil then msg="nil" end
	if msg==true then msg="true" end
	if msg==false then msg="false" end
	msg = "RaidUI: " .. msg
	DEFAULT_CHAT_FRAME:AddMessage(msg,1,1,1)
end


function RUI_Debug(msg)
	if not (RUI_Settings.Debug) then return; end
	
	if msg==nil then msg="nil" end
	if msg==true then msg="true" end
	if msg==false then msg="false" end
	msg = "RaidUI: " .. msg
	DEFAULT_CHAT_FRAME:AddMessage(msg,1,1,1)
end


function RUI_Get_DebuffType(tUnit_Name, tDebuffType)
	if not (tUnit_Name) or not (tDebuffType) then return; end;
	local i=1
	local name, rank, icon, count, debuffType, duration, timeLeft, isMine, isStealable;		
	local name = "test"
	while ( name ) do
		name, rank, icon, count, debuffType, duration, timeLeft, isMine, isStealable = UnitDebuff(tUnit_Name, i);
		if (debuffType) then
			if (debuffType == tDebuffType) then 
				return timeLeft, duration, count
			end
		end
		i = i + 1;
	end
	return 
end


function RUI_Check_Debuffs(tUnit_Name) -- Returns poison, disease, magic, curse, weakenedsoul, Spiritofredemption
-- Check to see if the member can be cured of a harmful effect
	-- Do this before showing buffs so Weakened Soul is detected before drawing buffs
	-- Iterator for debuffs
		
	-- Variables to determine if cures should be shown
	-- This is done in case there are multiples of one kind of effect
	local poisonshow = nil;
	local diseaseshow = nil;
	local magicshow = nil;
	local curseshow = nil;
	local weakenedsoul = nil;
	local spirit_of_redemption = nil; 
	local maxtimeleft = 0
	
	local name, rank, icon, count, debuffType, duration, timeLeft, isMine, isStealable;		
	for i=1, 16 do		
		name, rank, icon, count, debuffType, duration, timeLeft, isMine, isStealable = UnitDebuff(tUnit_Name, i);
		if (debuffType) then
			if (debuffType == "Curse") then 
				curseshow = true; 
			end
			if (debuffType == "Disease") then 
				diseaseshow =  true; 
			end
			if (debuffType == "Magic") then 
				magicshow = true; 
			end
			if (debuffType == "Poison") then 
				poisonshow = true; 
			end
		end
		if (name) then
			if (name=="Weakened Soul") then weakenedsoul = true; end;
			if (name=="Spirit of Redemption") then spirit_of_redemption = true; end;
		end
	end
		
	return poisonshow, diseaseshow, magicshow,	curseshow, weakenedsoul;
end


function RUI_Get_Buff_Times(tUnit_Name, tBuff_Name, tMine)
	--name, rank, icon, count, debuffType, duration, expirationTime, isMine, isStealable = UnitBuff(unit, index or name [, castable])

	if not (tUnit_Name) or not (tBuff_Name) then return; end;
	
	local i = 1;
	local name, rank, icon, count, debuffType, duration, exptime, isMine, isStealable;		
	local name = "test"
	while ( name ) do
		name, rank, icon, count, debuffType, duration, exptime, isMine, isStealable = UnitBuff(tUnit_Name, i);
		if (name) and (name==tBuff_Name) then 
			if not (tMine) then
				return exptime, duration, count, 1;
			elseif (isMine) and (isMine=="player") then
				--RUI_Chat("Buff is mine. Buff="..name..", Unit="..UnitName(isMine));
				return exptime, duration, count, 1;
			end
		end
		i = i + 1;
	end
	return;
end

function RUI_Check_for_Buff(tUnit_Name, tBuff_Name)
	if not (tUnit_Name) or not (tBuff_Name) then return; end;
	
	local i = 1;
	local name, rank, icon, count, debuffType, duration, timeLeft, isMine, isStealable;		
	local name = "test"
	while ( name ) do
		name, rank, icon, count, debuffType, duration, timeLeft, isMine, isStealable = UnitBuff(tUnit_Name, i);
		if (name) and (name==tBuff_Name) then 
			return true;
		end
		i = i + 1;
	end
	return;
end

function RUI_Check_for_Buff(tUnit_Name, tBuff_Name)
	if not (tUnit_Name) or not (tBuff_Name) then return; end;
	
	local i = 1;
	local name, rank, icon, count, debuffType, duration, timeLeft, isMine, isStealable;		
	local name = "test"
	while ( name ) do
		name, rank, icon, count, debuffType, duration, timeLeft, isMine, isStealable = UnitBuff(tUnit_Name, i);
		if (name) and (name==tBuff_Name) then 
			return true;
		end
		i = i + 1;
	end
	return;
end

	

function RUI_Check_for_WeaponBuff(tBuff_Name)
	local tHas_WeaponBuff = nil
	if not (tBuff_Name) then
		return tHas_WeaponBuff;
	end
	
	local hasMainHandEnchant, mainHandExpiration, mainHandCharges, hasOffHandEnchant, offHandExpiration, offHandCharges;
	
	hasMainHandEnchant, mainHandExpiration, mainHandCharges, hasOffHandEnchant, offHandExpiration, offHandCharges = GetWeaponEnchantInfo();
	
	
	
	if ( hasMainHandEnchant ) then
		local tspace = string.find(tBuff_Name, " ")
		if (tspace) then
			tBuff_Name = string.sub(tBuff_Name, 1, tspace-1)
		end
		local slotId, textureName;
	
		slotId, textureName = GetInventorySlotInfo('MainHandSlot');
	
		RUI_Tooltip:ClearLines();
		RUI_Tooltip:SetInventoryItem('player', slotId);
		
		for i = 1, RUI_Tooltip:NumLines() do
			if getglobal('RUI_TooltipTextLeft' .. i):GetText() then
				local line = getglobal('RUI_TooltipTextLeft' .. i):GetText();
				if ( string.find(line, tBuff_Name) ) then
					tHas_WeaponBuff = 1;
					do break end; --WINTROW.6, break for efficiency
				end
			end
		end
	end
	return tHas_WeaponBuff;
end














